var zh_CN = {
		/***********common****************/
		BACK : '返回',
		SENDDATA : '下发权限',
		NETWORK_OUTLINE : '当前网络异常，已启用离线模式。',
		INTOSTORAGE : '新锁具入库',
		PADLOCK : '挂锁',
		RECOVERY : '回收',
		RECORDS : '开锁记录',
		POWER : '用户权限',
		MAP : '地图',
		PLEASE_PADLOCK : '请挂锁',
		PADLOCK_SUCCESS : '挂锁成功',
		PADLOCK_FAILURE : '挂锁失败，请重试',
		STEP1 : '1.请确认钥匙是否打开；',
		STEP2 : '2.请确认钥匙是否和手机APP已经正常建立连接；',
		STEP3 : '3.将钥匙对准锁芯轻轻推入，当听到"嘀嘀"声之后轻轻向右转动钥匙；',
		STEP4 : '4.根据当前的网络状态将加载地理位置信息，并按照提示提交完成挂锁。',
		RECOVERY_LOCK : '回收锁具',
		RECOVLOCK : '请回收锁具',
		RECOVLOCK_SUCCESS : '回收锁具成功',
		RECOVLOCK_FAILURE  : '回收锁具失败，请重试',
		LOCK_NUM : '锁具编码',
		RECOVERY_STEP4 : '4.根据当前的网络状态将加载锁具信息，并按照提示提交完成锁具回收。',
		INIT_LOCK_STEP4 : '4.确保网络连接稳定，并按照提示提交完成入库操作。',
		INIT_LOCK_MODEL : '切换入库模式',
		SEPARATION_MODEL : '锁具设备分离模式',
		SEPARATION_RELATED_MODEL :'锁具设备关联模式',
		INIT_NETWORK_OUTLINE : '当前网络异常，新锁具入库不支持离线操作,请检查网络。',
		LOCK_PERSONNEL : '上锁人员',
		LOCK_TIME : '上锁时间',
		EQUIPMENT : '设备',
		ADDRESS : '安装地址',
		LONGITUDE : '经度',
		LATITUDE : '纬度',
		INPUT_EQUIP_NAME : '请输入设备名称',
		SELECT_EQUIP : '请选择设备',
		INPUT_ADDRESS : '请输入详细地址',
		INPUT_LONG : '请输入经度',
		INPUT_LATI : '请输入纬度',
		SURE_PADLOCK : '确认挂锁',
		NO_DATA : '暂无数据',
		ACCORD_EQUIP : '按设备',
		ACCORD_USER : '按人员',
		REFRESH : '下拉刷新',
		PERSON : '开锁人员',
		UNLOCK_EQUIP : '开锁设备',
		MY_PERMISSION : '我的权限',
		NO_REPETITION : '不重复',
		PER_DAY : '每天',
		PER_WEEK : '每周',
		PER_MONTH : '每月',
		PERMISSION_DATE : '授权日期',
		WORK_TIME : '工作时间',
		OFFLINE_DATA : '离线数据',
		/***********login*****************/
		
		USERNAME : '用户名',
		PASSWORD : '密码',
		OLDPASSWORD : '旧密码',
		NEWPASSWORD : '新密码',
		CONFIRMPASSWORD : '确认密码',
		LOGIN : '登录',
		LOGIN_ERROR_NAME : '用户名或密码错误！',
		LOGIN_ERROR_CHECK : '用户未审核，请联系主站管理员！',
		RESET_PASSWORD : '修改密码',
		FORGET_PASSWORD : '忘记密码',
		PRIVATE_MSG : '点击登录表示您已阅读并同意',
		PRIVATE_FILE:"<<隐私政策>>",
		SUBMIT : '提交',
		
		/************manage*********************/
		KEY_MANAGE : '钥匙管理',
		SEARCH : '搜索',
		CANCEL : '取消',
		SAVE : '保存',
		DELETE : '删除',
		KEY_PARAM_CONFIG : '钥匙参数配置',
		KEY_NAME : '钥匙别名:',
		INPUT_KEY_NAME : '请输入钥匙别名',
		KEY_MAC_ADDR : '连接地址:',
		INPUT_KEY_MAC_ADDR : '请输入连接地址',
		KEY_IMG_TIP_CONTENT : '钥匙所贴标签即为连接地址',
		DEVICE_MANAGE : '设备管理',
		UNLOCK : '未上锁',
		LOCKED : '已上锁',
		DEVICE_NAME : '名称',
		DEVICE_INSTALL : '上锁人员',
		DEVICE_INSTALL_TIME : '上锁时间',
		DEVICE_ADDRESS : '地址',
		DEVICE_PARAM_CONFIG : '设备参数配置',
		INPUT_DEVICE_NAME : '请输入设备名称',
		INPUT_DEVICE_ADDRESS : '请输入地址',
		DEVICE_AREA : '区域',
		USER_MANAGE : '用户管理',
		ADMIN_CLASS : '管 理 员',
		NORMAL_CLASS : '普通用户',
		USER_PARAM_CONFIG : '用户参数配置',
		INITPASSWD : '初始化密码',
		USER_NAME : '账号',
		INPUT_USER_NAME : '请输入账号',
		USER_REAlNAME : '姓名',
		INIT_PASS_TIP : '* 注：初始密码与账号相同，请及时修改',
		INPUT_USER_REALNAME : '请输入姓名',
		USER_GROUP : '班组',
		INPUT_USER_GROUP : '请选择班组',
		USER_TITLE : '职务',
		INPUT_USER_TITLE : '请选择职务',
		USER_KEY : '持有钥匙',
		INPUT_USER_KEY : '请选择钥匙',
		USER_PERMISSION : '操作权限',
		USER_TYPE : '用户类型',
		SELECT_USER_GROUP : '选择班组',
		SURE_BTN : '确认',
		SELECT_USER_TITLE : '选择职务',
		SELECT_BL_KEY : '选择钥匙',
		USER_TYPE_ADMIN : '管理员',
		USER_TYPE_NORMAL : '普通用户',
		OPERATOR_INIT : '初始化入库',
		OPERATOR_INSTALL : '挂锁',
		OPERATOR_OPEN : '开锁维护',
		OPERATOR_RECOVER : '回收锁具',
		RELATION_PARAM_CONFIG : '授权参数配置',
		PERMISSION_MANAGE : '授权管理',
		PERMISSION_DEVICE : '设备',
		INPUT_PERM_DEVICE : '请先选择设备',
		PERMISSION_USER : '用户',
		INPUT_PERM_USER : '请先选择用户',
		PERMISSION_STARTDATE : '权限生效日期',
		INPUT_PERM_STARTDATE : '请先选择生效日期',
		PERMISSION_ENDDATE : '权限过期日期',
		INPUT_PERM_ENDDATE : '请先选择过期日期',
		PERMISSION_STARTTIME : '工作开始时间',
		INPUT_PERM_STARTTIME : '请先选择开始时间',
		PERMISSION_ENDTIME : '工作结束时间',
		INPUT_PERM_ENDTIME : '请先选择结束时间',
		PERMISSION_TYPE : '重复类型',
		INPUT_PERM_TYPE : '请先选择重复类型',
		PERM_SELECT_DEVICE : '选择设备',
		PERM_SELECT_USER : '选择用户',
		AREA_MANAGE : '区域管理',
		GROUP_MANAGE : '班组管理',
		TITLE_MANAGE : '职务管理',
		AREA_PARAM_CONFIG : '区域参数配置',
		GROUP_PARAM_CONFIG : '班组参数配置',
		TITLE_PARAM_CONFIG : '职务参数配置',
		AREA_NAME : '区域名称',
		INPUT_AREA_NAME : '请先输入区域名称',
		GROUP_NAME : '班组名称',
		INPUT_GROUP_NAME : '请先输入班组名称',
		TITLE_NAME : '职务名称',
		INPUT_TITLE_NAME : '请先输入职务名称'
		
}