angular.module('btapp.controllers', [])
.controller('common.login',function($scope,$rootScope,$cordovaToast,$stateParams,$state,$ionicPopup,
		$cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $timeout, hlService,ssBlKey,ysBlKey,ssSecondBlKey, blcache,CONSTANT){
	/**
	 * 处理隐私政策
	 */
	if(window.localStorage.firstFlag == undefined || window.localStorage.firstFlag == null){
		CONSTANT.showPrivateMsg();
	}

	$rootScope.openLink = function (url) {
		
		window.open(url, '_self','location=yes');
	}
	
	if(window.localStorage.userName!=null){
		$scope.user={
			username:window.localStorage.userName,
			password:window.localStorage.password
		};
	};
	if(window.localStorage.hisData == null){
		window.localStorage.hisData = '[]';
	}
	$rootScope.timecounter = 0;

/**
 * 本控制器中注释代码为报文交互过程跟踪日志代码
 * 连同ssBlKey中注释代码全部释放后会生成日志文件可跟踪查询
 * 请勿删除 
 * leaf
 * */	
//$rootScope.fileName = "bltoothLog.txt";
//$rootScope.fileURL = cordova.file.externalRootDirectory;
//createFile($rootScope.fileName);
	


	function createFile(fileName){
		var dateTime = new Date();
		var m = (dateTime.getMonth()+1) < 10 ? '0'+(dateTime.getMonth()+1) : (dateTime.getMonth()+1);
    	var d = dateTime.getDate() < 10 ? '0'+ dateTime.getDate() : dateTime.getDate();
    	var h = dateTime.getHours() < 10 ? '0' + dateTime.getHours() : dateTime.getHours();
    	var min = dateTime.getMinutes() < 10 ? '0' + dateTime.getMinutes() : dateTime.getMinutes();
    	var s = dateTime.getSeconds() < 10 ? '0' + dateTime.getSeconds() : dateTime.getSeconds();
		var timeFormate = dateTime.getFullYear()+"-"+m+"-"+d+" "
						+ h + ":" + min + ":" + s;
		var datas = "日志文件创建：" + timeFormate;
    	$cordovaFile.writeFile(cordova.file.externalRootDirectory, fileName,datas, true);
    	
	}
	
	$rootScope.writeFile = function(path,file,data){
		$cordovaFile.writeExistingFile(path, file, data);
	};
	
	// 登录按钮监听 -- by 冯永发 2017-8-14
	$scope.signIn = function(user) {
		$rootScope.showPopup = function(popupText) {
	        // 自定义弹窗
	        var myPopup = $ionicPopup.show({
	        	title : constantDefine.tips,//'提示',
	            template: popupText,
	            scope: $rootScope
	        });
	        $timeout(function() {
	           myPopup.close(); // 3秒后关闭弹窗
	        }, 3000);
		};
		
		if(window.localStorage.firstFlag == undefined || window.localStorage.firstFlag == null){
			$rootScope.showPopup("您未同意隐私政策，将会影响应用的使用。您可尝试重新打开本应用。");
			return;
		}
		
	    var now = new Date();
	    var devTime = now.getTime();
        if(!user || user.username == null || user.username == undefined){
            $rootScope.showPopup(constantDefine.username_error);
            return;
        }
        if(!user || user.password == null || user.password == undefined){
            $rootScope.showPopup(constantDefine.password_error);
            return;
        }
	    hlService.user.login().save({
      		name:user.username, 
      		password:hex_md5(user.password),
      		devTime : devTime
      	},
      	function(res){
      		if(!res.timeSync) {
      			$cordovaToast.showShortCenter(constantDefine.login_time_error);//"您的手机时间不正确，请重新设置后登录";
      			window.localStorage.updateTime = res.updateTime;
	    		$state.go('login');
	    	} else if (res.login) { 
      			window.localStorage.userName = res.name; //用户名
    			window.localStorage.password = user.password; //密码
    			window.localStorage.updateTime = res.updateTime;
    			window.localStorage.userId = res.userId; //用户id
    			window.localStorage.admin= res.admin;//fangrong 新增是否为管理员
    			window.localStorage.sysId= res.sysId;//fangrong sysid系统id    			
    			window.localStorage.groupId = res.grpId;
    			window.localStorage.keyName = res.keyMacAddr; //蓝牙钥匙连接名
    			window.localStorage.lockPerm = JSON.stringify(res.permission); //权限信息
    			window.localStorage.opt = res.opt; //用户配置下功能按钮权限
    			window.localStorage.locksets = JSON.stringify(res.locksets); //用户所属系统内的所有锁具列表
    			window.localStorage.devices = JSON.stringify(res.devices); // 用户所属系统的所有设备或者权限范围内的设备
    			window.localStorage.keyBaseKey = res.keyBaseKey;
    			window.localStorage.keyControlKey = res.keyControlKey;
    			window.localStorage.lastLoginTime = getLastTime();
				$scope.keyName = res.keyMacAddr;
			    $rootScope.lockPerm = res.permission;
			  //不以TKL-开头命名的蓝牙钥匙默认为易锁厂家，测试钥匙TKL-000001c5除外
			    if($scope.keyName && ($scope.keyName == 'TKL-000001c5' || $scope.keyName.indexOf('TKL-') == -1)){
			    	$rootScope.bluetooth = ysBlKey;
			    } else if($scope.keyName && $scope.keyName.indexOf('HLTKL-') != -1) { //易锁协议二开发使用HLTKL-命名
			    	$rootScope.bluetooth = ssSecondBlKey;
			    } else { //兼容易锁厂家版本一
			    	$rootScope.bluetooth = ssBlKey;
			    }
			    $rootScope.bluetooth.online = true;
			    $rootScope.bluetooth.keyName = $scope.keyName;
			    //根密钥
			    if(isNotNullOrEmpty(res.keyBaseKey)){
			    	$rootScope.bluetooth.gKey = res.keyBaseKey;
			    } 
			    //控制密钥
			    if(isNotNullOrEmpty(res.keyControlKey)){
			    	$rootScope.bluetooth.controlKey = res.keyControlKey;
			    }
			    // 先同步离线数据
      			saveCacheData(res.userId);
      			
				refreshLocation();
    			$state.go('home');
	    	} else {
	    		$cordovaToast.showShortCenter(constantDefine.login_error);//"用户名或密码错误！");
	    		window.localStorage.updateTime = res.updateTime;
	    		$state.go('login');
	    	}
      	},
      	function(res){
      		//$cordovaToast.showShortCenter(constantDefine.network_error);//"网络连接不可用");
      		var blueService = {
      			'service_uuid':'f000c0e0-0451-4000-b000-000000000000',
	  			'notifyCharacteristic_uuid':'f000c0e2-0451-4000-b000-000000000000',
	  			'characteristic_uuid':'f000c0e1-0451-4000-b000-000000000000'
	  		};
      		if (isDevTimeSync(window.localStorage.updateTime)) {
      			if(user.username == window.localStorage.userName && user.password == window.localStorage.password){
    	      		/*if (isLongTimeOffline()) { // 是否长时间离线
    	      			$cordovaToast.showShortCenter('由于长时间未在线登录，请开启网络，重新登录');
    	      			$state.go("login");
    	      		} else {
    	      			offlineLoginHandler();
    	      		}*/
    	      		offlineLoginHandler();
    	      	}else{
    	      		$state.go("login");
    	      	}
      		} else {
      			$cordovaToast.showShortCenter(constantDefine.login_time_error);//"您的手机时间不正确，请重新设置后登录");
	    		$state.go('login');
      		}
      	});
	};
	function saveCacheData(userId) {
		savePubDeviceByCache(userId);
		savePubHisDataByCache();
	}
	function savePubDeviceByCache(userId) {
		var devices = blcache.getPubDeviceByCache();
		if (devices.length > 0) {
			hlService.home.savePubDeviceFromCache().save(devices,function(res){
				savePubLocksetByCache(userId);
	    		$rootScope.showPopup(constantDefine.device_sync);//"设备数据同步成功。");
          	});
		}
	}
	function savePubLocksetByCache(userId) {
		var locksets = blcache.getPubLocksetByCache();
    	if(locksets.length > 0){
    		hlService.home.savePubLocksetFromCache().save(locksets,function(res){
    			refreshAllCache();
	    		$rootScope.showPopup(constantDefine.lock_sync);//"锁具数据同步成功。");
          	});
	    }
	}
	function savePubHisDataByCache() {
		var hisRecords = blcache.getPubHisDataByCache();
    	if(hisRecords.length !=0){
	    	hlService.home.savePubHisDataList().save(hisRecords,function(res){
	    		window.localStorage.hisData = '[]';
	    		$rootScope.showPopup(constantDefine.lock_sync);//"开锁数据同步成功。");
          	});
	    }
	}
	function refreshAllCache() {
		hlService.user.getPermissionsAndDevicesAndLocksetsByUserId(window.localStorage.userId).get(function(res){
			blcache.refreshAllCache(res);
		},
		function(res){
			// tips:update cache error
			
		});
	}
	function refreshLocation() {
		if ($rootScope.networkState != 'none') {	
            CONSTANT.getBaiduMapLocation(function(point){
                if(point){
                    var geoc = new window.BMap.Geocoder();
                    geoc.getLocation(point, function(rs){
                        var addComp = rs.addressComponents;
                        window.localStorage.longitude = point.lng;
                        window.localStorage.latitude = point.lat;
                        window.localStorage.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                    });
                }
            });
//            var geolocation = new window.BMap.Geolocation();
//			geolocation.getCurrentPosition(function(r){
//
//				if(this.getStatus() == BMAP_STATUS_SUCCESS){
//                    var geoc = new window.BMap.Geocoder();
//                    var point = new window.BMap.Point(r.point.lng,r.point.lat);
//					geoc.getLocation(point, function(rs){
//						var addComp = rs.addressComponents;
//						window.localStorage.longitude = r.point.lng;
//						window.localStorage.latitude = r.point.lat;
//						window.localStorage.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
//					});
//				}
//			},{enableHighAccuracy: true,timeout: 10000});
		}
	}
    // 离线登录操作
    function offlineLoginHandler() {
    	$scope.keyName = window.localStorage.keyName;
		  $rootScope.lockPerm = window.localStorage.lockPerm; 
		  //不以TKL-开头命名的蓝牙钥匙默认为易锁厂家，测试钥匙TKL-000001c5除外
		  if($scope.keyName == 'TKL-000001c5' || $scope.keyName.indexOf('TKL-') == -1){
		      $rootScope.bluetooth = ysBlKey;
		  } else if($scope.keyName.indexOf('HLTKL-') != -1) { //易锁协议二开发使用HLTKL-命名
		      $rootScope.bluetooth = ssSecondBlKey;
		  } else { //兼容易锁厂家版本一
		      $rootScope.bluetooth = ssBlKey;
		  }
		  //根密钥
	      if(isNotNullOrEmpty(window.localStorage.keyBaseKey)){
	    	$rootScope.bluetooth.gKey = window.localStorage.keyBaseKey;
	      } 
	      //控制密钥
	      if(isNotNullOrEmpty(window.localStorage.keyControlKey)){
	    	$rootScope.bluetooth.controlKey = window.localStorage.keyControlKey;
	      }
		  $rootScope.bluetooth.online = false;
		  $rootScope.networkState = 'none';
		  $rootScope.bluetooth.keyName = $scope.keyName;
		  window.localStorage.updateTime = getLastTime();
		  $state.go("home");
    }
    function isNullOrEmpty(str) {
    	if (str == null || str == 'null' || str =='') {
    		return true;
    	}
    	return false;
    }
    function isNotNullOrEmpty(str) {
    	return !isNullOrEmpty(str);
    }
    function getLastTime() {
    	var date = new Date();
    	return date.getTime();
    }
    // 暂时设置如果时间超过24小时认为长时间未登录，需要在线登录以便刷新最新的缓存
    function isLongTimeOffline() {
    	if (isNullOrEmpty(window.localStorage.lastLoginTime)) {
    		return true;
    	}
    	if (moreThanXHours()) {
    		return true;
    	}
    	return false;
    }
    // 超过X小时
    function moreThanXHours() {
    	var nowTime = getLastTime();
    	if ((nowTime - window.localStorage.lastLoginTime) > 86400000) { // 24h = 24 * 60m * 60s * 1000ms
    		return true;
    	}
    	return false;
    }
    function isDevTimeSync(updateTime) {
    	var nowTime = getLastTime();
    	if (updateTime - 0 > 0) {
    		if ((nowTime - updateTime) < -60000) { // 60s
        		return false;
        	}
    	}
    	return true;
    }
})
.controller('common.home',function($scope,$rootScope,$stateParams,$state,$interval,$ionicPopup,$timeout,$ionicPopover,hlService,blcache,$ionicSideMenuDelegate,CONSTANT,ENV){
	$scope.admin = window.localStorage.admin;
	$rootScope.bluetooth.isInstalling = false;
	$rootScope.bluetooth.isReturn = false;
	$rootScope.bluetooth.isInit = false;
	$rootScope.bluetooth.isMain = true;
	$rootScope.closed = 0;
    //1 …………………………………………………………连接设备
	$scope.scanKeyDevice = function(){
		
		if($rootScope.bluetooth.deviceId != "" && $rootScope.bluetooth.deviceId !=null && $rootScope.bluetooth.scanFlag){
			$rootScope.bluetooth.isConnected($rootScope.bluetooth.deviceId, function(res){
				//$rootScope.bluetooth.status = "已连接";
			}, function(res){
				scanBLE();
			});
	    }
	};
	function scanBLE() {
		$rootScope.bluetooth.status = "扫描连接中……";
        if(ionic.Platform.isIOS()){
        	ble.isEnabled(function(){
        	}, function(){
        		$ionicPopup.alert({
        			title: '提示',
        		    template: '您好，钥匙连接需要使用手机蓝牙，打开后点击主页钥匙图标即可重新连接。',
        		    buttons:[{
        		    	text:'确定',
        		    	type:'button-default'
        		    	
        		    }]
        		}).then(function(res) {
        			if (window.cordova && window.cordova.plugins.settings) {
        			    window.cordova.plugins.settings.open("settings");
        			}
        		});
        	});
            $rootScope.bluetooth.scanDevice();
        }else if(ionic.Platform.isAndroid()){
            ble.isEnabled(function(){
                $rootScope.bluetooth.scanDevice();
            },function(){
				$ionicPopup.alert({
        			title: '提示',
        		    template: '您好，钥匙连接需要使用手机蓝牙，打开后点击主页钥匙图标即可重新连接。',
        		    buttons:[{
        		    	text:'确定',
        		    	type:'button-default'
        		    	
        		    }]
        		});
			});
        }
	}
// test hidden	
	//$scope.scanKeyDevice();
    //2 …………………………………………………………处理状态显示
    var getBluetoothStatus = function(){
    	//$rootScope.timecounter += 1;
    	//$rootScope.openLog = $rootScope.timecounter;
        if($rootScope.bluetooth.deviceId){
            $rootScope.bluetooth.isConnected($rootScope.bluetooth.deviceId,function(res){
                //$rootScope.openLog = 'isConnected:' + JSON.stringify(res) + '->' + $rootScope.timecounter;
                if ($rootScope.bluetooth.notifyError) {
                    $rootScope.bluetooth.reconnect();
                } else {
                    $scope.getKeyDetail();
                    $rootScope.bluetooth.connected = true;
                }
                
            },function(res){
                if ($rootScope.bluetooth.isReconnecting) {
                    $rootScope.bluetooth.reconnect();
                }
            });
        } else {
            if ($rootScope.bluetooth.isReconnecting) {
                $scope.scanKeyDevice();
            }
            
        }
    };
    //3 ……………………………………………………………获取连接钥匙基本信息
    $scope.getKeyDetail = function(){
    	var data = '01 00 00';
    	//$rootScope.openLog = '01码报文发送:' + JSON.stringify(data) + '->' + $rootScope.timecounter;
    	$rootScope.closed += 1;
    	$rootScope.dis = 0;
    	$rootScope.discon = false;
    	$rootScope.bluetooth.sendData1(data, function(res){
    		$rootScope.closed = 0;
    		$rootScope.bluetooth.status = constantDefine.already_connected;//'已连接';
    		//$rootScope.openLog += '01命令码响应:' + JSON.stringify(res) + '->' + $rootScope.timecounter;
    		var responseKeyInfo = $rootScope.bluetooth.keyInfo;
    		if(responseKeyInfo){
    			var firstData = parseInt(responseKeyInfo[8],16);
    			var secondData = parseInt(responseKeyInfo[9],16);
    			var voltage = firstData * 256 + secondData;
    			$rootScope.version = constantDefine.version;//"版本 : version1";
    			if(voltage > 4100){
    				$rootScope.voltage = constantDefine.key_quantity + "100%";
    			} else if(voltage < 3700){
    				$rootScope.voltage = constantDefine.key_quantity + "0%";
    			} else {
    				var quantity = (voltage - 3700) / (0.4 * 1000);
        			$rootScope.voltage = constantDefine.key_quantity + (quantity*100).toFixed(2) + "%";
    			}
    		}
    	}, function(res){
    		//$rootScope.openLog = "发送获取钥匙电量命令失败！！！请尝试重新进行蓝牙连接。"; // 为啥要写这个提示信息呢，害的我否定了所有的努力！！！！ 这里就不打印了，因为下次循环连接成功之后还会进入改函数
    		//$rootScope.bluetooth.status = "已断开";
    	});
    	$rootScope.closedTimer = setTimeout(function(){
    		//$rootScope.openLog += '每次都执行吗？？' + $rootScope.closed;
    		//$rootScope.openLog += '->' + $rootScope.closed;
    		if ($rootScope.closed > 1) {
    			$rootScope.bluetooth.status = constantDefine.connect_close; //'已断开，正在释放资源，请稍后连接……';
    			$rootScope.version = '';
    			$rootScope.voltage = '';
    			$rootScope.voltage = '';
    			/*$rootScope.bluetooth.status = '已断开';
    			$rootScope.bluetooth.disconnectcallback(function(res){
    				$rootScope.bluetooth.status = '已断开le' + JSON.stringify(res);
    				//scanBLE();
    				$rootScope.bluetooth.reconnect();
    			}, function(){});*/
    		}
    	},1000);
    };
    function getBluetoothClosedStatus() {
    	if ($rootScope.closed > 0) {
    		$rootScope.bluetooth.disconnect();
    		$rootScope.bluetooth.isReconnecting = true;
    	}
    }
    function saveCacheData() {
    	if ($rootScope.networkState != 'none') {
    		var userId = window.localStorage.userId;
    		savePubDeviceByCache(userId);
    		savePubHisDataByCache();
    		syncServerTime();
    	}
    	
	}
	function savePubDeviceByCache(userId) {
		var devices = blcache.getPubDeviceByCache();
		if (devices.length > 0) {
			hlService.home.savePubDeviceFromCache().save(devices,function(res){
				savePubLocksetByCache(userId);
	    		//$rootScope.showPopup("设备数据同步成功。");
          	});
		}
	}
	function savePubLocksetByCache(userId) {
		var locksets = blcache.getPubLocksetByCache();
    	if(locksets.length > 0){
    		hlService.home.savePubLocksetFromCache().save(locksets,function(res){
    			refreshAllCache();
	    		//$rootScope.showPopup("锁具数据同步成功。");
          	});
	    }
	}
	function syncServerTime() {
		var now = new Date();
		var random = now.getTime();
		hlService.home.syncSeverTime(random).get(function(res){
			window.localStorage.upateTime = res.time;
		});
		
	}
	function savePubHisDataByCache() {
		var hisRecords = blcache.getPubHisDataByCache();
    	if(hisRecords.length !=0){
	    	hlService.home.savePubHisDataList().save(hisRecords,function(res){
	    		blcache.clearPubHisDataCache();
	    		//$rootScope.showPopup("开锁数据同步成功。");
          	});
	    }
	}
	function refreshAllCache() {
		hlService.user.getPermissionsAndDevicesAndLocksetsByUserId(window.localStorage.userId).get(function(res){
			blcache.refreshAllCache(res);
		},
		function(res){
			// tips:update cache error
			
		});
	}
	function refreshLocation() {
		if ($rootScope.networkState != 'none') {
            CONSTANT.getBaiduMapLocation(function(point){
                if(point){
                    var geoc = new BMap.Geocoder();
                    geoc.getLocation(point, function(rs){
                        
                        var addComp = rs.addressComponents;
                        window.localStorage.longitude = point.lng;
                        window.localStorage.latitude = point.lat;
                        window.localStorage.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                    });
                }
            });
//			var geolocation = new BMap.Geolocation();
//			geolocation.getCurrentPosition(function(r){
//				if(this.getStatus() == BMAP_STATUS_SUCCESS){
//					var geoc = new BMap.Geocoder();
//					var point = new BMap.Point(r.point.lng,r.point.lat);
//					geoc.getLocation(point, function(rs){
//						var addComp = rs.addressComponents;
//						window.localStorage.longitude = r.point.lng;
//						window.localStorage.latitude = r.point.lat;
//						window.localStorage.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
//					});
//				}
//			},{enableHighAccuracy: true,timeout: 10000});
		}
		
	}
	if ($rootScope.saveCacheDataTimer == null) {
		//test hidden
 		// $rootScope.saveCacheDataTimer = $interval(function(){
	    // 	saveCacheData();
	    // }, 1000);
	}
    
    if ($rootScope.refreshLocationTimer == null) {
    	// $rootScope.refreshLocationTimer = $interval(function(){
        // 	refreshLocation();
        // }, 180000); // 3m refresh
    }
    
    if ($rootScope.statusTimer == null) {
//test hidden   	
    	// $rootScope.statusTimer = $interval(function(){
        // 	getBluetoothStatus();
        // },1000);
    }
    
    /**
     * 处理页面功能按钮显示
     * */
    $scope.initBtnShow = false;
    $scope.installBtnShow = false;
    $scope.recoverBtnShow = false;
    $scope.mainBtnShow = false;
    var opts = window.localStorage.opt.split(",");
    for(var i=0;i<opts.length;i++){
    	var opt = opts[i];
    	if(opt == 0){
    		$scope.initBtnShow = true;
    	} else if(opt == 1){
    		$scope.installBtnShow = true;
    	} else if(opt == 2){
    		$scope.mainBtnShow = true;
    	}else if(opt ==3){
    		$scope.recoverBtnShow = true;
    	}
    }
    
    //4 ………………………………………………………………开锁记录页面
    $scope.getHisData = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('hisdatas');
    	
    };
    
    //5 ………………………………………………………………用户权限页面
    $scope.getPermData = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('permissions');
    };
    
   //6 ………………………………………………………………地图页面
    $scope.getLocationData = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('locationData');
    };
    
    //7 ………………………………………………………………获取权限记录数量 …………………………未使用
    $scope.getPermissionListCount = function(){
    	var userId = window.localStorage.userId;
    	hlService.home.getPermissionListCount(window.localStorage.userId).get(function(res){
    		var permCount = res.NUM;
    		if(permCount != $rootScope.lockPerm.length){
    			//获取新的权限列表信息	
    			hlService.home.getPermissionListByUserId(window.localStorage.userId).query(function(res){ // 该后台请求方法找那个如果有-100的记录，值返回-100的记录，需要注意使用，不能有效获取权限列表
    				$rootScope.lockPerm = res;
    				window.localStorage.lockPerm = JSON.stringify(res);
    	    	});
    		}
    	});
    };
    
    //8 ………………………………………………………………安装锁具
    $scope.installLockset = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('installLocksetView');
    };
    
    //9 ………………………………………………………………右上角弹出菜单
	$ionicPopover.fromTemplateUrl('pages/menu.html', {
      scope: $scope
    }).then(function(popover) {
        $scope.popover = popover;
    });
    $scope.openPopover = function($event) {
      $scope.popover.show($event);
    };
    $scope.closePopover = function() {
      $scope.popover.hide();
    };
    $scope.$on('$destroy', function() {
      $scope.popover.remove();
    });
    
    //10 ………………………………………………………………新锁具入库操作
    $scope.count = 0;
    $scope.noActive = true;
	$scope.isActive = false;
    $scope.initBtnHandler = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.isInit = true;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isReturn = false;
    	$rootScope.bluetooth.switchDepend = 1;
    	$state.go('initLocksetDepend1');
    };
    
    //11 …………………………………………………………………回收操作
    $scope.recoverLockset = function(){
    	if (!blcache.isDevTimeSync()) {
    		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
    		return;
    	}
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = true;
    	$state.go('recoverLocksetView');
    };
    
    //12 ……………………………………………………………………初始化钥匙密钥
    $scope.initKeyBtnHandler = function(){
    	if($rootScope.bluetooth.status == constantDefine.already_connected){
    		$scope.key = {};
    		$scope.showConfirm = function() {
    			var confirmPopup = $ionicPopup.confirm({
    				title: constantDefine.key_param,
    				templateUrl: 'privKeyParams.html',
    				scope: $scope,
    				buttons:[
    				         {text:constantDefine.cancel, onTap: function(e) {return false;}},  //取消
    				         {text:constantDefine.cancel, type: 'button-positive', onTap: function(e) {
    				        	 if($scope.key.baseKey == null) {
    				        		 $rootScope.showPopup(constantDefine.input_base_key);//"请先输入根密钥");
    								 e.preventDefault();
    				        	 } else if ($scope.key.controlKey == null){
    								$rootScope.showPopup(constantDefine.input_control_key);//"请先输入控制密钥");
    								e.preventDefault();
    							 } else {
    								var formate = /^[0-9a-fA-F]{1,2}$/;
    								var inputIds = $scope.key.baseKey.split(" ");
    								if(inputIds.length != 8){
    									$rootScope.showPopup(constantDefine.base_key_error);//"根密钥长度非法!");
    									e.preventDefault();
    								} else {
    									for(var i=0;i<inputIds.length;i++){
    										if(!formate.test(inputIds[i])){
    											$rootScope.showPopup(constantDefine.base_key_bit_error + (i+1));//"根密钥出现非16进制编码!字节位："
    											e.preventDefault();
    										}
    									}
    								}
    								var versions = $scope.key.controlKey.split(" ");
    								if(versions.length != 8){
    									$rootScope.showPopup(constantDefine.control_key_error);//"控制密钥长度非法!");
    									e.preventDefault();
    								} else {
    									for(var i=0;i<versions.length;i++){
    										if(!formate.test(versions[i])){
    											$rootScope.showPopup(constantDefine.control_key_bit_error + (i+1)); //"控制密钥出现非16进制编码!字节位："
    											e.preventDefault();
    										}
    									}
    								}
    								return true;
    							 }
    				         }}
    				] //确认
    			});
        		confirmPopup.then(function(res) {
        			var newBaseKey = $scope.key.baseKey;
        			$rootScope.openLog = constantDefine.input_baseKey + newBaseKey + '<br>'; //"输入的根密钥 ："
    	        	var newControlKey = $scope.key.controlKey;
    	        	$rootScope.openLog = constantDefine.input_controlKey + controlKey + '<br>'; //"输入的控制密钥 ："
    	        	//05码数据段位明文
    	        	var keyData = newBaseKey + " " + newControlKey;
    	        	$rootScope.openLog = constantDefine.code05_data + keyData + '<br>'; //"05码数据段位明文 ："
    	        	//05码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）
    	        	var secretKey = ($rootScope.bluetooth.key + $rootScope.bluetooth.gKey).split(' ').join('');
    	        	$rootScope.openLog = constantDefine.code05_secret;//"05码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）：" 
    	        		+ secretKey + '=' + $rootScope.bluetooth.key + '---' + $rootScope.bluetooth.gKey + '<br>';
    	        	//05码数据段进行RC4加密
    	        	var secretData = $rootScope.bluetooth.HloveyRC4($rootScope.bluetooth.stringToBytes(keyData), $rootScope.bluetooth.stringToBytesForNoSpace(secretKey));
    	        	$rootScope.openLog = constantDefine.code05_RC4_secret + secretData + '<br>';//"05码数据段进行RC4加密 ："
    	        	//生成密文校验位
    	        	var checkData =$rootScope.bluetooth.XorCheck(secretData,secretData.length);
    	        	$rootScope.openLog = constantDefine.code05_check_data + checkData + '<br>';//"05码生成密文校验位 ："
    	        	var newSecretData = new Uint8Array(secretData.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
    	    		for(var i=0;i<secretData.length;i++){
    	    			newSecretData[i] = secretData[i];
    	    		}
    	    		newSecretData[newSecretData.length-1] = checkData; 
    	    		
    	    		var sendDataInfo = [05,16]; //发送数据
    	    		
    	    		for(var i=0;i<newSecretData.length;i++){
    	    			var d = newSecretData[i].toString(16);
    	    			sendDataInfo[i+2] = d;
    	    		}
    	    		$rootScope.openLog = constantDefine.send_05_secretData + sendDataInfo;
    	    		$rootScope.bluetooth.sendData1(sendDataInfo.join(" "),function(res){
    	    			newBaseKey = newBaseKey.split(' ').join('');
    		        	newControlKey = newControlKey.split(' ').join('');
    		        	$rootScope.bluetooth.gKey = newBaseKey;
    		        	$rootScope.bluetooth.controlKey = newControlKey;
    		        	var params = {
    		        		"userId" : window.localStorage.userId,
    		        		"macAddr" : $rootScope.bluetooth.keyName,
    		        		"baseKey" : newBaseKey,
    		        		"controlKey" : newControlKey
    		        	};
    		        	hlService.home.updateKeysByKeyName().save(params,function(res){
    		        		if(res.NUM == -1){
    		          			$rootScope.showPopup(constantDefine.init_key_fail);//"初始化钥匙密钥失败!!!");
    		          		}else{
    		          			$rootScope.showPopup(constantDefine.init_key_success);//"初始化钥匙密钥成功!!!");
    		          		}
    		        	}, function(res){
    		    			$rootScope.showPopup(constantDefine.network_lazy);//"网络偷懒啦!!!");
    		    		});
    	    		});
        		});
    		};
    		$scope.showConfirm();
    	} else {
    		$rootScope.showPopup(constantDefine.init_bluetooth_error);//"请在蓝牙连接状态下进行初始化操作!");
    	}
    };
    
    //13 ……………………………………………………………………初始化锁具信息
    $scope.initLocksetBtnHandler = function(){

    	if($rootScope.bluetooth.status == constantDefine.already_connected){
    		$scope.lock = {};
    		$scope.showConfirm = function() {
				var confirmPopup = $ionicPopup.confirm({
					title: constantDefine.lock_param, //确认对应
					templateUrl: 'inputParams.html',
					scope: $scope,
					buttons:[
					         {text:constantDefine.cancel, onTap: function(e) {return false;}},  //取消
					         {text:constantDefine.confirm, type: 'button-positive', onTap: function(e) {
					        	 if($scope.lock.id == null || $scope.lock.version == null){
									$rootScope.showPopup(constantDefine.lock_input_param);//"请先输入锁具参数");
									e.preventDefault();
								 } else {
									var formate = /^[0-9a-fA-F]{1,2}$/;
									var inputIds = $scope.lock.id.split(" ");
									if(inputIds.length != 4){
										$rootScope.showPopup(constantDefine.device_num_error);//"设备号长度非法!");
										e.preventDefault();
									} else {
										for(var i=0;i<inputIds.length;i++){
											if(!formate.test(inputIds[i])){
												$rootScope.showPopup(constantDefine.device_bit_error + (i+1));//"设备号出现非16进制编码!字节位:"
												e.preventDefault();
											}
										}
									}
									var versions = $scope.lock.version.split(" ");
									if(versions.length != 2){
										$rootScope.showPopup(constantDefine.version_num_error);//"版本号长度非法!");
										e.preventDefault();
									} else {
										for(var i=0;i<versions.length;i++){
											if(!formate.test(versions[i])){
												$rootScope.showPopup(constantDefine.version_bit_error + (i+1));//"版本号出现非16进制编码!字节位:"
												e.preventDefault();
											}
										}
									}
									return true;
								 }
					         }}
					] //确认
				});
				confirmPopup.then(function(res) {
					if(res) {
			        	//06码数据段位明文
			        	var data = $scope.lock.id + " " + $scope.lock.version;
			        	//06码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）
			        	var secretKey = ($rootScope.bluetooth.key + $rootScope.bluetooth.gKey).split(' ').join('');
			        	//06码数据段进行RC4加密
			        	var secretData = $rootScope.bluetooth.HloveyRC4($rootScope.bluetooth.stringToBytes(data), $rootScope.bluetooth.stringToBytesForNoSpace(secretKey));
			        	//生成密文校验位
			        	var checkData =$rootScope.bluetooth.XorCheck(secretData,secretData.length);
			        	
			        	var newSecretData = new Uint8Array(secretData.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
			    		for(var i=0;i<secretData.length;i++){
			    			newSecretData[i] = secretData[i];
			    		}
			    		newSecretData[newSecretData.length-1] = checkData; 
			    		
			    		var sendDataInfo = [06,06]; //发送数据
			    		
			    		for(var i=0;i<newSecretData.length;i++){
			    			var d = newSecretData[i].toString(16);
			    			sendDataInfo[i+2] = d;
			    		}
						$rootScope.openLog = constantDefine.send_06_secretData + sendDataInfo;//"发送06命令码密文 ："
						$rootScope.bluetooth.sendData1(sendDataInfo.join(" "),function(res){ 
							
						},function(res){
							$rootScope.openLog = constantDefine.init_lock_send_error;//"初始化锁具命令发送失败!请重试或重新进行蓝牙连接。";
						});
					}
				});
    		};
    		$scope.showConfirm();
    	} else {
    		$rootScope.showPopup(constantDefine.init_bluetooth_error);//"请在蓝牙连接状态下进行初始化操作!");
    	}
    };
    
    //14 ……………………………………………………………………初始化钥匙信息
    $scope.initBLockBtnHandler = function(){

    	if($rootScope.bluetooth.status == constantDefine.already_connected){
    		$scope.key = {};
    		$scope.showConfirm = function() {
				var confirmPopup = $ionicPopup.confirm({
					title: constantDefine.key_params,//"钥匙参数", //确认对应
					templateUrl: 'keyParams.html',
					scope: $scope,
					buttons:[
					         {text:constantDefine.cancel, onTap: function(e) {return false;}},  //取消
					         {text:constantDefine.confirm, type: 'button-positive', onTap: function(e) {
					        	 if($scope.key.id == null || $scope.key.version == null){
									$rootScope.showPopup(constantDefine.lock_input_param);//"请先输入锁具参数");
									e.preventDefault();
								 } else {
									var formate = /^[0-9a-fA-F]{1,2}$/;
									var inputIds = $scope.key.id.split(" ");
									if(inputIds.length != 12){
										$rootScope.showPopup(constantDefine.id_num_error);//"id号长度非法!");
										e.preventDefault();
									} else {
										for(var i=0;i<inputIds.length;i++){
											if(!formate.test(inputIds[i])){
												$rootScope.showPopup(constantDefine.id_bit_error + (i+1) );//"id号出现非16进制编码!字节位:"
												e.preventDefault();
											}
										}
									}
									var versions = $scope.key.version.split(" ");
									if(versions.length != 2){
										$rootScope.showPopup(constantDefine.version_num_error);//"版本号长度非法!");
										e.preventDefault();
									} else {
										for(var i=0;i<versions.length;i++){
											if(!formate.test(versions[i])){
												$rootScope.showPopup(constantDefine.version_bit_error + (i+1));//"版本号出现非16进制编码!字节位:"
												e.preventDefault();
											}
										}
									}
									return true;
								 }
					         }}
					] //确认
				});
				confirmPopup.then(function(res) {
					if(res) {
			        	//07码数据段位明文
			        	var data = $scope.key.id + " " + $scope.key.version;
			        	//07码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）
			        	var secretKey = ($rootScope.bluetooth.key + $rootScope.bluetooth.gKey).split(' ').join('');
			        	//07码数据段进行RC4加密
			        	var secretData = $rootScope.bluetooth.HloveyRC4($rootScope.bluetooth.stringToBytes(data), $rootScope.bluetooth.stringToBytesForNoSpace(secretKey));
			        	//生成密文校验位
			        	var checkData =$rootScope.bluetooth.XorCheck(secretData,secretData.length);
			        	
			        	var newSecretData = new Uint8Array(secretData.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
			    		for(var i=0;i<secretData.length;i++){
			    			newSecretData[i] = secretData[i];
			    		}
			    		newSecretData[newSecretData.length-1] = checkData; 
			    		
			    		var sendDataInfo = [07,12]; //发送数据
			    		
			    		for(var i=0;i<newSecretData.length;i++){
			    			var d = newSecretData[i].toString(16);
			    			sendDataInfo[i+2] = d;
			    		}
						$rootScope.openLog = constantDefine.send_07_secretData + sendDataInfo; //"发送07命令码密文 ："
						$rootScope.bluetooth.sendData1(sendDataInfo.join(" "),function(res){ 
							
						},function(res){
							$rootScope.openLog = constantDefine.init_key_send_error;//"初始化钥匙命令发送失败!请重试或重新进行蓝牙连接。";
						});
					}
				});
    		};
    		$scope.showConfirm();
    	} else {
    		$rootScope.showPopup(constantDefine.init_bluetooth_error);//"请在蓝牙连接状态下进行初始化操作!");
    	}
    };
    
    //未上锁设备加载
    hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
		$scope.deviceList = res;
		window.localStorage.deviceList = JSON.stringify(res);
	},function(res){
		$scope.deviceList = JSON.parse(window.localStorage.deviceList);
	});
    
    //加载侧面子菜单
    $scope.toggleRight = function() {
        $ionicSideMenuDelegate.toggleRight();
        $ionicSideMenuDelegate.canDragContent();
	};
	$scope.appVersion = ENV.version;
    $scope.userName = window.localStorage.userName;
    $scope.keyName = window.localStorage.keyName;
    
    $scope.redirectPages = function(menu){
		if(menu == 0){
			$state.go('resetPassword');
		}
    	if( menu == 1){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('keyManage');
    	} else if( menu == 2){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('deviceManage');
    	} else if( menu == 3){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('userManage');
    	} else if( menu == 4){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('permissionManage');
    	} else if( menu == 5){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('areaManage');
    	} else if( menu == 6){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('groupManage');
    	} else if( menu == 7){
    		if (!blcache.isDevTimeSync()) {
        		$rootScope.showPopup(constantDefine.operation_time_error);//"您的手机时间设置不正确，请先设置后再操作");
        		return;
        	}
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.switchDepend = 1;
        	$state.go('titleManage');
    	}
    }
})
.controller('common.hisData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	
	$scope.getPubHisDataByUserId = function(){
		hlService.home.getPubHisDataListByUserId(window.localStorage.userId).query(function(res){
			for(var i=0;i<res.length;i++){
				var obj = res[i];
				obj.DATE = dateFormate(obj.OPT_DATE);
				res[i] = obj;
			}
			
			$scope.hisDataList = res;
			window.localStorage.hisDataList = JSON.stringify(res);
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.hisDataList = JSON.parse(window.localStorage.hisDataList);
		});
	};
	$scope.getPubHisDataByUserId();
	
	var dateFormate = function(time){
		var date = new Date(time*1000);
		return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate() + " "
				+ date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
	};
})
.controller('common.hisdatas',function($scope,$rootScope,$stateParams,$ionicLoading,$state,$interval,$timeout,hlService,blcache){
	$scope.admin = window.localStorage.admin;
	$scope.domore = false;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.hisDataList = [];
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPubHisDataByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadPubHisDataByUserId(); 
		}
	};
	$scope.getPubHisDataByUserId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			hlService.home.getPubHisDataListByUserId(window.localStorage.userId, $scope.start, $scope.limit).query(function(res){
				for(var i=0;i<res.length;i++){
					var obj = res[i];
					obj.date = dateFormate(obj.optDate);
					obj.time = timeFormate(obj.optDate);
					res[i] = obj;
				}
				
				$scope.hisDataList = res;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	//$scope.getPubHisDataByUserId();
	
	$scope.moreHisDatas = function() {
		$state.go('hisDataAdmin');
	};
	function loadPubHisDataByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			hlService.home.getPubHisDataListByUserId(window.localStorage.userId, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							obj.date = dateFormate(obj.optDate);
							obj.time = timeFormate(obj.optDate);
							res[i] = obj;
							$scope.hisDataList.push(res[i]);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	function dateFormate(time){
		var date = new Date(time*1000);
		return getYmdByDate(date);
	}
	function timeFormate(time){
		var date = new Date(time*1000);
		return getHmsByDate(date);
	}
	// 获取时间的绝对秒
	function getSecondsByDate (date) {
    	return date.getTime() / 1000;
    }
    // yyyy-MM-dd, if middleLine=true :yyyyMMdd
	function getYmdByDate(date, middleLine) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var format = date.getFullYear()+ "-" + month + "-" + day;
    	if (middleLine) {
    		format = date.getFullYear()+ "" + month + "" + day;
    	}
    	return format;
    }
    // HH:mm:ss ,if middleDot=true : HHmmss
    function getHmsByDate(date, middleDot) {
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = hours + ":" + minutes + ":" + seconds;
    	if (middleDot) {
    		format = hours + "" + minutes + "" + seconds;
    	}
    	return format;
    }
    // yyyy-MM-dd HH:mm:ss
    function getYmdHmsByDate(date) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = date.getFullYear()+ "-" + month + "-" + day + " "
			+ hours + ":" + minutes + ":" + seconds;
    	return format;
    }
})
.controller('common.hisDataAdmin',function($scope,$rootScope,$stateParams,$ionicLoading,$state,$interval,$timeout,hlService,blcache){
	$scope.mode = 'device';
	$scope.deviceActived = "active";
	$scope.userActived = "";
	$scope.domore = false;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.hisDataList = [];
	$scope.first = true;
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.toggle = function(mode) {
		$scope.mode = mode;
		if (mode == 'device') {
			$scope.deviceActived = "active";
			$scope.userActived = "";
		} else {
			$scope.deviceActived = "";
			$scope.userActived = "active";
		}
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPubHisDataBySysId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadPubHisDataBySysId(); 
		}
		
	};
	
	$scope.getPubHisDataBySysId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
		} else {
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			hlService.home.getPubHisDataListBySysId(window.localStorage.sysId, $scope.start, $scope.limit).query(function(res){
				
				for(var i=0;i<res.length;i++){
					var obj = res[i];
					obj.date = dateFormate(obj.optDate);
					obj.time = timeFormate(obj.optDate);
					res[i] = obj;
				}
				
				$scope.hisDataList = res;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');
			});
		}
		
	};
	//$scope.getPubHisDataBySysId();
	function loadPubHisDataBySysId() {
		if ($rootScope.networkState == 'none') {
			$scope.domore = true;  
            $scope.$broadcast('scroll.infiniteScrollComplete');
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
		} else {
			$scope.start++;
			var timer = null; 
			hlService.home.getPubHisDataListBySysId(window.localStorage.sysId, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							obj.date = dateFormate(obj.optDate);
							obj.time = timeFormate(obj.optDate);
							res[i] = obj;
							$scope.hisDataList.push(res[i]);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true;  
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	function dateFormate(time){
		var date = new Date(time*1000);
		return getYmdByDate(date);
	}
	function timeFormate(time){
		var date = new Date(time*1000);
		return getHmsByDate(date);
	}
	// 获取时间的绝对秒
	function getSecondsByDate (date) {
    	return date.getTime() / 1000;
    }
    // yyyy-MM-dd, if middleLine=true :yyyyMMdd
	function getYmdByDate(date, middleLine) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var format = date.getFullYear()+ "-" + month + "-" + day;
    	if (middleLine) {
    		format = date.getFullYear()+ "" + month + "" + day;
    	}
    	return format;
    }
    // HH:mm:ss ,if middleDot=true : HHmmss
    function getHmsByDate(date, middleDot) {
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = hours + ":" + minutes + ":" + seconds;
    	if (middleDot) {
    		format = hours + "" + minutes + "" + seconds;
    	}
    	return format;
    }
    // yyyy-MM-dd HH:mm:ss
    function getYmdHmsByDate(date) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = date.getFullYear()+ "-" + month + "-" + day + " "
			+ hours + ":" + minutes + ":" + seconds;
    	return format;
    }
})
.controller('common.hisDataAdmin1',function($scope,$rootScope,$stateParams,$ionicLoading,$state,$interval,$timeout,hlService,blcache){
	$scope.mode = 'device';
	$scope.deviceActived = "active";
	$scope.userActived = "";
	$scope.domore = false;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.hisDataList = [];
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.toggle = function(mode) {
		$scope.mode = mode;
		if (mode == 'device') {
			$scope.deviceActived = "active";
			$scope.userActived = "";
		} else {
			$scope.deviceActived = "";
			$scope.userActived = "active";
		}
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPubHisDataBySysId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadPubHisDataBySysId(); 
		}
	};
	$scope.getPubHisDataBySysId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
		} else {
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			hlService.home.getPubHisDataListBySysId(window.localStorage.sysId, $scope.start, $scope.limit).query(function(res){
				
				for(var i=0;i<res.length;i++){
					var obj = res[i];
					obj.date = dateFormate(obj.optDate);
					obj.time = timeFormate(obj.optDate);
					res[i] = obj;
				}
				
				$scope.hisDataList = res;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');
			});
		}
		
	};
	//$scope.getPubHisDataBySysId();
	function loadPubHisDataBySysId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unsearch);//"当前离线模式下无法查看开锁记录");
			$scope.domore = true;  
            $scope.$broadcast('scroll.infiniteScrollComplete');
		} else {
			$scope.start++;
			var timer = null; 
			hlService.home.getPubHisDataListBySysId(window.localStorage.sysId, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							obj.date = dateFormate(obj.optDate);
							obj.time = timeFormate(obj.optDate);
							res[i] = obj;
							$scope.hisDataList.push(res[i]);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true;  
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			$scope.$on("$destroy", function () {   
	            $timeout.cancel(timer);  
	        });
		}
		
	}
	function dateFormate(time){
		var date = new Date(time*1000);
		return getYmdByDate(date);
	}
	function timeFormate(time){
		var date = new Date(time*1000);
		return getHmsByDate(date);
	}
	// 获取时间的绝对秒
	function getSecondsByDate (date) {
    	return date.getTime() / 1000;
    }
    // yyyy-MM-dd, if middleLine=true :yyyyMMdd
	function getYmdByDate(date, middleLine) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var format = date.getFullYear()+ "-" + month + "-" + day;
    	if (middleLine) {
    		format = date.getFullYear()+ "" + month + "" + day;
    	}
    	return format;
    }
    // HH:mm:ss ,if middleDot=true : HHmmss
    function getHmsByDate(date, middleDot) {
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = hours + ":" + minutes + ":" + seconds;
    	if (middleDot) {
    		format = hours + "" + minutes + "" + seconds;
    	}
    	return format;
    }
    // yyyy-MM-dd HH:mm:ss
    function getYmdHmsByDate(date) {
    	var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    	var ymd = "" + date.getFullYear() + month + day;
    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
    	var format = date.getFullYear()+ "-" + month + "-" + day + " "
			+ hours + ":" + minutes + ":" + seconds;
    	return format;
    }
}).controller('common.permData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	
	$scope.getPermListByUserId = function(){
		hlService.home.getPermissionListByUserId(window.localStorage.userId).query(function(res){
			for(var i=0;i<res.length;i++){
				var obj = res[i];
				obj.startDate = dateFormate(obj.startDate);
				obj.endDate = dateFormate(obj.endDate);
				obj.startTime = timeFormate(obj.startTime);
				obj.endTime = timeFormate(obj.endTime);
				obj.typeDesc = reTypeFormate(obj.type);
				obj.reday = reDayFormate(obj.type,obj.reday);
				res[i] = obj;
			}
			
			$scope.lockPermList = res;
			window.localStorage.lockPermList = JSON.stringify(res);
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.lockPermList = JSON.parse(window.localStorage.lockPermList);
		});
	};
	$scope.getPermListByUserId();
	
	var dateFormate = function(date){
		date = date + " ";
		var year = date.substring(0,4);
		var month = date.substring(4,6);
		var day = date.substring(6,8);
		return year + "-" + month + "-" + day;
	};
	
	var timeFormate = function(time){
		time = time + "";
		if(time.length == 5){
			var hour = time.substring(0,1);
			var minutes = time.substring(1,3);
			var seconds = time.substring(3,5);
			return hour + ":" + minutes + ":" + seconds;
		}else if(time.length == 6){
			var hour = time.substring(0,2);
			var minutes = time.substring(2,4);
			var seconds = time.substring(4,6);
			return hour + ":" + minutes + ":" + seconds;
		}else{
			return time;
		}
	};
	
	var reTypeFormate = function(type){
		if(type == 0){
			return constantDefine.NO_REPETITION;//"不重复";
		} else if(type == 1){
			return constantDefine.PER_DAY;//"每天";
		} else if(type == 2){
			return constantDefine.PER_WEEK;//"每周";
		} else if(type == 3){
			return constantDefine.PER_MONTH;//"每月";
		}
	};
	
	var reDayFormate = function(type,reDay){
		if(reDay != null){
			if(type == 2){
				var day = ["周日","周一","周二","周三","周四","周五","周六"];
				var reDays = reDay.split(",");
				var format = "";
				for(var i=0;i<reDays.length;i++){
					format += day[reDays[i]] + ",";
				}
				return format.substring(0, format.length-1);
			}else if(type == 3){
				if((reDay.split(",")).length>8){
					var reDays = reDay.split(",");
					var format = "";
					for(var i=0;i<8;i++){
						format += reDays[i] + ",";
					}
					return format+"……";
				}else{
					return reDay + "号";
				}
				
			}
		}else{
			return "";
		}
		
	};
	
})
.controller('common.permissions',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicLoading,hlService,blcache){
	$scope.domore = false;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.lockPermList = [];
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPermPagesByUserId();
            }, 1000);
			$scope.first = false;
		} else {
			loadPermPagesByUserId(); 
		}
	};
	$scope.getPermListByUserId = function(){
		$scope.start = 0;
		$scope.limit = 20;
		$scope.domore = false;
		hlService.home.getPermissionPagesByUserId(window.localStorage.userId,$scope.start, $scope.limit).query(function(res){
			$scope.lockPermList = formatPermissions(res);
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.lockPermList = formatPermissions(blcache.getDeviceUserRelationByUserId(window.localStorage.userId));
		});
	};
	var loadPermPagesByUserId = function() {
		$scope.start++;
		var timer = null; 
		hlService.home.getPermissionPagesByUserId(window.localStorage.userId, $scope.start, $scope.limit).query(function(res){
			if (res) {
				if (res.length != 0) {
					for(var i=0;i<res.length;i++){
						var obj = res[i];
						obj.startDate = dateFormate(obj.startDate);
						obj.endDate = dateFormate(obj.endDate);
						obj.startTime = timeFormate(obj.startTime);
						obj.endTime = timeFormate(obj.endTime);
						obj.typeDesc = reTypeFormate(obj.type);
						obj.reday = reDayFormate(obj.type,obj.reday);
						res[i] = obj;
						$scope.lockPermList.push(res[i]);
					}
				}
				if (res.length == 0){
					$scope.domore = true; 
				}
				timer = $timeout(function () {
	                $scope.$broadcast('scroll.infiniteScrollComplete');  
	            }, 1500);
			} else {
				$scope.domore = true;  
                $scope.$broadcast('scroll.infiniteScrollComplete');
			}
			$scope.$broadcast('scroll.infiniteScrollComplete'); 
		},function(res){
			$timeout.cancel(timer);
			$scope.lockPermList = formatPermissions(blcache.getDeviceUserRelationByUserId(window.localStorage.userId));
			$scope.domore = true; 
			$scope.$broadcast('scroll.infiniteScrollComplete'); 
		});
		 $scope.$on("$destroy", function () {   
             $timeout.cancel(timer);  
         });
	};
	
	//lockid 共四位长度，不够补位
	var formateLockId = function(lockId){
		if(lockId.length > 8){
			lockId = lockId.substring(0,8);
		} else if(lockId.length ==7){
			lockId = "0" + lockId;
		} else if(lockId.length == 6){
			lockId = "00" + lockId;
		} else if(lockId.length == 5){
			lockId = "000" + lockId;
		} else if(lockId.length == 4){
			lockId = "0000" + lockId;
		} else if(lockId.length == 3){
			lockId = "00000" + lockId;
		} else if(lockId.length == 2){
			lockId = "000000" + lockId;
		} else if(lockId.length == 1){
			lockId = "0000000" + lockId;
		}
		return lockId;
		
	};
	
	var formateSendDataToArray = function(string){
		var array = new Uint8Array(string.length/2);
		 for (var i = 0; i < string.length;) {
			 array[i/2] = string.substring(i,i+2);
			 i = i + 2;

		 }
		 return array;
	}
	
	$scope.sendPermissionData = function(){
		//$scope.lockPermList;
		
		//console.log($scope.lockPermList);

		var lockIds = [];
		var lockStrs = "";
		for(var i=0; i<$scope.lockPermList.length; i++){
			var permission = $scope.lockPermList[i];
			var device = permission.device;
			
			if(device != null){
				//全部设备
				if(device.deviceId == -100){
					//设置所有钥匙均有此权限
				} else {
					var lockId = $rootScope.bluetooth.decimalRadixToHex(device.lockId);
					var startDate = permission.startDate;
					startDate = startDate.replace(/-/g,"");
					startDate = startDate.substring(2,startDate.length);
					var startTime = permission.startTime;
					startTime = startTime.replace(/:/g,"");
					var endDate = permission.endDate;
					endDate = endDate.replace(/-/g,"");
					endDate = endDate.substring(2,endDate.length);
					var endTime = permission.endTime;
					endTime = endTime.replace(/:/g,"");
					
					//直接进行转码存储  ------------------------------ leaf
					lockIds[i] = formateLockId(lockId) + startDate + startTime + endDate + endTime; 
					lockStrs += formateLockId(lockId) + startDate + startTime + endDate + endTime;
				}
			}
			
		}
		
		//console.log(lockIds);
		
		//08码数据段位明文(首位是操作类型 1：新增；2：删除；)
		var length = $rootScope.bluetooth.decimalRadixToHex(lockIds.length);
		var dataLength = length.length < 2 ? ('0'+length):length;
    	var data = dataLength + lockStrs;

    	//    	//08码数据段加密密钥（动态密钥做高8字节、根密钥做低8字节）
    	//var secretKey = ($rootScope.bluetooth.key + $rootScope.bluetooth.gKey).split(' ').join('');
    	//08码数据段进行RC4加密
    	//var secretData = $rootScope.bluetooth.HloveyRC4($rootScope.bluetooth.stringToBytes(data), $rootScope.bluetooth.stringToBytesForNoSpace(secretKey));
    	//生成密文校验位
		//var dataArray = $rootScope.bluetooth.stringToBytesForNoSpace(data);
		var dataArray = formateSendDataToArray(data);

    	var checkData =$rootScope.bluetooth.XorCheck(dataArray,dataArray.length);

    	var newSecretData = new Uint8Array(dataArray.length + 1);//修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
		for(var i=0;i<dataArray.length;i++){
			newSecretData[i] = dataArray[i];
		}
		newSecretData[newSecretData.length-1] = '0x'+$rootScope.bluetooth.decimalRadixToHex(checkData); 

		var length = $rootScope.bluetooth.decimalRadixToHex(2 + 16*lockIds.length);
		var sendDataInfo = [08,length,01]; //发送新增数据
		
		for(var i=0;i<newSecretData.length;i++){
			var d = newSecretData[i];
			if(i == newSecretData.length-1){
				d = newSecretData[i].toString(16);
			}
			
			sendDataInfo[i+3] = d;
		}
		$rootScope.openLog = constantDefine.send_08_secretData + sendDataInfo;//"发送08命令码密文 ："
		
		$rootScope.bluetooth.sendData1(sendDataInfo.join(" "),function(res){ 
			
		},function(res){
			alert(res);
			$rootScope.openLog = constantDefine.send_permissiong_error;//"下发权限失败。";
		});
		
	};
	
	var formatPermissions = function(res) {
		for(var i=0;i<res.length;i++){
			var obj = res[i];
			obj.startDate = dateFormate(obj.startDate);
			obj.endDate = dateFormate(obj.endDate);
			obj.startTime = timeFormate(obj.startTime);
			obj.endTime = timeFormate(obj.endTime);
			obj.typeDesc = reTypeFormate(obj.type);
			obj.reday = reDayFormate(obj.type,obj.reday);
			res[i] = obj;
		}
		return res;
	};
	var dateFormate = function(date){
		date = date + " ";
		var year = date.substring(0,4);
		var month = date.substring(4,6);
		var day = date.substring(6,8);
		return year + "-" + month + "-" + day;
	};
	
	var timeFormate = function(hms){
		if (hms == null || hms === "")return "";
		hms = hms.toString();
		if (hms.length == 1) {
			hms = "00000" + hms;
		} else if (hms.length == 2) {
			hms = "0000" + hms;
		} else if (hms.length == 3) {
			hms = "000" + hms;
		} else if (hms.length == 4) {
			hms = "00" + hms;
		} else if (hms.length == 5) {
			hms = "0" + hms;
		}
		var formatString = hms.substring(0,2)+":"+hms.substring(2,4)+":"+hms.substring(4,6);
		return formatString;
	};
	
	var reTypeFormate = function(type){
		if(type == 0){
			return constantDefine.NO_REPETITION;//"不重复";
		} else if(type == 1){
			return constantDefine.PER_DAY;//"每天";
		} else if(type == 2){
			return constantDefine.PER_WEEK;//"每周";
		} else if(type == 3){
			return constantDefine.PER_MONTH;//"每月";
		}
	};
	
	var reDayFormate = function(type,reDay){
		if(reDay != null){
			if(type == 2){
				var day = ["周日","周一","周二","周三","周四","周五","周六"];
				var reDays = reDay.split(",");
				var format = "";
				for(var i=0;i<reDays.length;i++){
					format += day[reDays[i]] + ",";
				}
				return format.substring(0, format.length-1);
			}else if(type == 3){
				if((reDay.split(",")).length>8){
					var reDays = reDay.split(",");
					var format = "";
					for(var i=0;i<8;i++){
						format += reDays[i] + ",";
					}
					return format+"……";
				}else{
					return reDay + "号";
				}
				
			}
		}else{
			return "";
		}
		
	};
	
}).controller('common.mapData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache,CONSTANT){
                 
	function initBaiduMap1() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.load_map_error);//"当前离线模式下无法加载实时地图定位");
    	} else {
    		hlService.home.getPubLocksetByPoint(window.localStorage.userId,0,0,0,0).query(function(res){
    			var map = new BMap.Map("container");
    	        map.addControl(new BMap.MapTypeControl());
    	        map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
    	        map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
    	        map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
    	        map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
    	        map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开    
    	        var localSearch = new BMap.LocalSearch(map);
    	        localSearch.enableAutoViewport(); //允许自动调节窗体大小
                for(var i=0;i<res.length;i++){
               	 var record = res[i];
                    var maker = addMarker(map, new window.BMap.Point(record.LONGITUDE, record.LATITUDE), i,record);  
                    //addInfoWindow(maker, record, i); 
                }
            },function(res){
                //$rootScope.showPopup("当前离线模式下无法加载实时地图定位");
            });
    	}
	}
    function initBaiduMap() {
    	if ($rootScope.networkState == 'none') {
    		$rootScope.showPopup(constantDefine.load_map_error);
    		return;
    	}
        try {
            var lng = $stateParams.lng;
            var lat = $stateParams.lat;

            var map = new BMap.Map("container");
            map.addControl(new BMap.MapTypeControl());
            map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
            map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
            map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
            map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
            map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开    
            var localSearch = new BMap.LocalSearch(map);
            localSearch.enableAutoViewport(); //允许自动调节窗体大小
	   
            if(lng != "" && lat != ""){
                var point = new BMap.Point(lng,lat);
                map.centerAndZoom(point, 20);
                var marker = new BMap.Marker(point);  
                map.addOverlay(marker);  
            } else {
                CONSTANT.getBaiduMapLocation(function(point){
                    if(point){
                        map.centerAndZoom(point,20);
                        var startLng = point.lng - 0.01;
                        var endLng = point.lng + 0.01;
                        var startLat = point.lat - 0.01;
                        var endLat = point.lat + 0.01;
                        //获取方圆范围内的点，后台已舍弃条件删选返回了所有点 -- leaf
                        hlService.home.getPubLocksetByPoint(window.localStorage.userId,startLng,endLng,startLat,endLat).query(function(res){
                            for(var i=0;i<res.length;i++){
                                var record = res[i];
                                var maker = addMarker(map, new window.BMap.Point(record.LONGITUDE, record.LATITUDE), i,record);
                                //addInfoWindow(maker, record, i);
                            }
                        },function(res){
                            $rootScope.showPopup(constantDefine.network_lazy);//"网络偷懒啦!!!");
                        });
                    } else {
                        //获取方圆范围内的点，后台已舍弃条件删选返回了所有点 -- leaf
                        hlService.home.getPubLocksetByPoint(window.localStorage.userId,startLng,endLng,startLat,endLat).query(function(res){
                            if(res.length > 0){
                                map.centerAndZoom(new window.BMap.Point(res[0].LONGITUDE, res[0].LATITUDE),20);
                            }
                            for(var i=0;i<res.length;i++){
                                var record = res[i];
                                var maker = addMarker(map, new window.BMap.Point(record.LONGITUDE, record.LATITUDE), i,record);
                                //addInfoWindow(maker, record, i);
                            }
                        },function(res){
                            $rootScope.showPopup(constantDefine.network_lazy);//"网络偷懒啦!!!");
                        });
                    }
                });
            }
        }catch(err) {
            console.log(err);
            $rootScope.showPopup(constantDefine.offline_loadmap_error);//"当前网络已断开或不稳定，无法开启地图");
        }
    }
    
    
	// 添加标注  
    function addMarker(map, point, index,record) {  
        var myIcon = new BMap.Icon("http://api.map.baidu.com/img/markers.png",  
            new BMap.Size(23, 25), {  
                offset: new BMap.Size(10, 25),  
                imageOffset: new BMap.Size(0, 0 - index * 25)  
            });  
        var marker = new BMap.Marker(point); 
        //pop弹窗标题  
        var title = '<div style="font-weight:bold;color:#CE5521;font-size:14px;text-align:center;">' + record.DEVNAME + '</div>';  
        //pop弹窗信息  
        var html = [];  
        html.push('<table cellspacing="0" style="table-layout:fixed;width:100%;font:12px arial,simsun,sans-serif"><tbody>');  
        html.push('<tr>');  
        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">'+constantDefine.location+'</td>');  
        html.push('<td style="vertical-align:top;line-height:16px">' + record.LOCATION + '</td>');  
        html.push('</tr>');
        html.push('<tr>');  
        html.push('<td style="vertical-align:top;line-height:16px;width:30%;margin-top:10px;">'+constantDefine.LOCK_TIME+'</td>');  
        html.push('<td style="vertical-align:top;line-height:16px;margin-top:10px;">' + dateFormate(record.TIME) + ' </td>');  
        html.push('</tr>');  
        html.push('</tbody></table>');  
        var searchInfoWindow = null;
    	searchInfoWindow = new BMapLib.SearchInfoWindow(map, html.join(""), {
			title  : title,      //标题
			width  : 290,             //宽度
			height : 85,              //高度
			panel  : "panel",         //检索结果面板
			enableSendToPhone:false,
			enableAutoPan : true,     //自动平移
			searchTypes   :[
				BMAPLIB_TAB_TO_HERE,  //到这里去
				BMAPLIB_TAB_FROM_HERE, //从这里出发
				BMAPLIB_TAB_SEARCH   //周边检索 
			],
			currentAddr : '上海浦东新区龙东大道3000号'        //自定义属性   -- by leaf
		});
        
    	marker.addEventListener("click", function(e){
    	    searchInfoWindow.open(marker);
        });
        
        
        map.addOverlay(marker);
        marker.setLabel(new BMap.Label(record.DEVNAME,{offset:new BMap.Size(-20,20),position:point}));
        return marker;  
    }  
//
//    // 添加信息窗口  
//    function addInfoWindow(marker, record) {  
//    	
//        //pop弹窗标题  
//        var title = '<div style="font-weight:bold;color:#CE5521;font-size:14px;text-align:center;">' + record.DEVNAME + '</div>';  
//        //pop弹窗信息  
//        var html = [];  
//        html.push('<table cellspacing="0" style="table-layout:fixed;width:100%;font:12px arial,simsun,sans-serif"><tbody>');  
//        html.push('<tr>');  
//        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">上锁时间:</td>');  
//        html.push('<td style="vertical-align:top;line-height:16px">' + dateFormate(record.TIME) + ' </td>');  
//        html.push('</tr>');  
//        html.push('<tr>');  
//        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">地点:</td>');  
//        html.push('<td style="vertical-align:top;line-height:16px">' + record.LOCATION + '</td>');  
//        html.push('</tr>');
//        html.push('</tbody></table>');  
//        var infoWindow = new BMap.InfoWindow(html.join(""), { title: title, width: 200 });  
//        var openInfoWinFun = function () {  
//            marker.openInfoWindow(infoWindow);  
//        };  
//        marker.addEventListener("click", openInfoWinFun);  
//        return openInfoWinFun;
//    }
   
    var dateFormate = function(time){
		if(time !=0 && time != null){
			var date = new Date(time*1000);
			return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate();
		}else{
			return 0;
		}
	};
    initBaiduMap();
    
})
.controller('common.mapLead',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state','blcache',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state, blcache){
	
	
	
	
	
	
	var map = new BMap.Map("leadMap");
    map.addControl(new BMap.MapTypeControl());
    map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
    map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
    map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
    map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
    map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开	
    var localSearch = new BMap.LocalSearch(map);
    localSearch.enableAutoViewport(); //允许自动调节窗体大小
	
    var point = new BMap.Point(121.639940,31.228950);
	map.centerAndZoom(point, 20);
	var marker = new BMap.Marker(point);  
    map.addOverlay(marker);  
    
    
    
    
    
    
}])
.controller('common.installLocksetView',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	var timer = $interval(function(){
		listener();
	},300);
	timer.then(success, error, notify);
	function success(){
		 // nothing
	}
	function error(){
		 // nothing
	} 
	function notify(){
	  // nothing
	}
	function listener() {
		if($rootScope.Lockset != null) {
			$interval.cancel(timer);
			if ($rootScope.Lockset != null  && $rootScope.Lockset.depend == 1) {
				$state.go('installLockset1');
			} else {
				$state.go('installLockset');
			}
		}
	}
	$scope.goback = function() {
		$state.go('home');
	};
	
}])
.controller('common.installLockset',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicModal','$ionicPopup','$ionicLoading','$ionicNavBarDelegate','$cordovaGeolocation','hlService','$state','blcache','CONSTANT',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicModal,$ionicPopup,$ionicLoading,$ionicNavBarDelegate,$cordovaGeolocation,hlService,$state, blcache,CONSTANT){  //注意：installLockset和installLockset1中的保存过程一模一样，最好能放到一个通用的作用域里处理
	var getFormatLockId = function() {
		return decimalRadixToHex($rootScope.lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId();
	var timer = $interval(function(){
		listener();
	},300);
	timer.then(success, error, notify);
	function success(){
		 // nothing
	}
	function error(){
		 // nothing
	} 
	function notify(){
	  // nothing
	}
	function listener() {
		if($rootScope.Lockset != null && $rootScope.Lockset.refresh) {
			
			$rootScope.Lockset.refresh = false;
			loadGPS();
		}
	}
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$ionicModal.fromTemplateUrl('pages/common/lastlocation.html', {
	    scope: $scope
	}).then(function(modal) {
	    $scope.modal = modal;
	});
	var dateFormate = function(time){
		if(time !=0 && time != null){
			var date = new Date(time*1000);
			return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate();
		}else{
			return 0;
		}
	};
	
	
	// 之前的代码，暂时注释，这里获取pubArea是做什么用呢？--by冯永发 2017-8-11
	/*hlService.home.getPubAreaData().query(function(res){
		$scope.areaList = res;
		window.localStorage.areaDataList = JSON.stringify(res);
	},function(res){
		$scope.areaList = JSON.parse(window.localStorage.areaDataList);
	});*/
	
	// 该功能不要了，挪到selectDevice控制器中进行选择 --by 冯永发 2017-8-16
	/*hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
		$scope.deviceList = res;
		window.localStorage.deviceList = JSON.stringify(res);
	},function(res){
		$scope.deviceList = JSON.parse(window.localStorage.deviceList); // TODO::这里的缓存没有纳入到最新的缓存机制中！！！
		
	});*/
	
	$scope.saveInstallInfo = function(lockset){
        if (lockset.pubDevice == null || lockset.pubDevice.deviceName == null || lockset.pubDevice.deviceName == '') {
        	$rootScope.showPopup(constantDefine.select_device);//"请先选择设备");
        } else {
        	lockset.deviceName = lockset.pubDevice.deviceName; // 将新的设备名称赋值给原有的设备名，保持一致
        	var pubDevice = {
				lockId : lockset.lockId,
				deviceId : lockset.pubDevice.deviceId,
				deviceName : lockset.deviceName,
				location : lockset.location,
				installer : $rootScope.Lockset.installer,
				time : $rootScope.Lockset.time,
				longitude : lockset.longitude,
				latitude : lockset.latitude,
                depend : lockset.depend
			};
        	$scope.saveInstallLockset(pubDevice);
        }
	};
	$scope.saveInstallLockset  = function(device) {
		hlService.home.updateInstallLocksetData().save(device,function(res){
      		if(res.NUM == -1){
      			$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:false});
      		}else{
      			$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:true});
      		}
      	},function(res){
      		$scope.cacheInstallLockset(device);
      	});
	};
	$scope.cacheInstallLockset = function(device) {
		blcache.installPubDeviceAndPubLockset(device);
		$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:true});
	};
	
	$scope.locationHandler = function(Lockset){
		if(Lockset.longitude!="" && Lockset.longitude!=null && Lockset.longitude!=undefined){
			$state.go("locationData",{lng:Lockset.longitude,lat:Lockset.latitude});
		}
		
	};
	$scope.showDevice = function() {
		$state.go("selectDevice");
	};
	$scope.goback = function() {
		$interval.cancel(timer);
		initInstallStatus();
	};
	$scope.setLastLocation = function(lastLoaction) {
		$rootScope.Lockset.longitude  = lastLoaction.longitude;
 	    $rootScope.Lockset.latitude = lastLoaction.latitude;
 	    $rootScope.Lockset.location = lastLoaction.location;
 	    $scope.modal.hide();
	};
	function loadGPS() {
		if ($rootScope.networkState == 'none') {
			$scope.show();
			var posOptions = {timeout: 10000, enableHighAccuracy: false};
		      $cordovaGeolocation.getCurrentPosition(posOptions)
		       .then(function (position) {
		    	   $rootScope.Lockset.latitude  = position.coords.latitude;
		    	   $rootScope.Lockset.longitude = position.coords.longitude;
		    	   $scope.hide();
		       }, function(err) {
		    	   $scope.hide();
				   showLastLocationModal();
		       });
		} else {
			$scope.show();
            
            CONSTANT.getBaiduMapLocation(function(point){
                if(point){
                    var geoc = new BMap.Geocoder();
                    geoc.getLocation(point, function(rs){
                        var addComp = rs.addressComponents;
                        $rootScope.Lockset.longitude = point.lng;
                        $rootScope.Lockset.latitude = point.lat;
                        $rootScope.Lockset.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                    });
                    $scope.hide();
                } else {
                    $scope.hide();
                    showLastLocationModal();
                    
                }
            });
            
//			var geolocation = new BMap.Geolocation();
//			geolocation.getCurrentPosition(function(r){
//				if(this.getStatus() == BMAP_STATUS_SUCCESS){
//					var geoc = new BMap.Geocoder();
//					var point = new BMap.Point(r.point.lng,r.point.lat);
//					geoc.getLocation(point, function(rs){
//						var addComp = rs.addressComponents;
//						$rootScope.Lockset.longitude = r.point.lng;
//						$rootScope.Lockset.latitude = r.point.lat;
//						$rootScope.Lockset.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
//					});
//					$scope.hide();
//				} else {
//					$scope.hide();
//					showLastLocationModal();
//				}
//			},{enableHighAccuracy: true});
		}
	}
	function showLastLocationModal() {
		if (window.localStorage.longitude != null && window.localStorage.longitude != '') {
 		   $scope.lastLocation = {
 			   longitude:   window.localStorage.longitude,
 			   latitude : window.localStorage.latitude,
 			   location : window.localStorage.location  
    	   };
 		   var timer = $timeout(function () {
 			  $scope.modal.show();
           }, 500);
 	   } else {
 		   $rootScope.showPopup(constantDefine.	get_location_error);//"无法获取实时定位信息，请手动输入");
 	   }
	}
	function initInstallStatus() {
		$rootScope.Lockset = null;
		$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	
		$ionicNavBarDelegate.back();
	}
	
}])
.controller('common.selectDevice',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','$ionicNavBarDelegate','hlService','$state','blcache',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	$scope.selectDevice = function(device) {
		$rootScope.Lockset.pubDevice = device;
		$scope.goback();
	};
	$scope.goback = function() {
		$state.go("installLockset");
	};
	$scope.getDevices = function() {
		hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
			$scope.deviceList = res;
			window.localStorage.deviceList = JSON.stringify(res);
		},function(res){
			$scope.deviceList = JSON.parse(window.localStorage.deviceList); // TODO::这里的缓存没有纳入到最新的缓存机制中！！！
			
		});
	};
	$scope.getDevices();
}])
.controller('common.installLockset1',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicModal','$ionicPopup','$ionicLoading','$ionicNavBarDelegate','$cordovaGeolocation','hlService','$state','blcache','CONSTANT',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicModal, $ionicPopup,$ionicLoading,$ionicNavBarDelegate,$cordovaGeolocation, hlService,$state, blcache,CONSTANT){
	var getFormatLockId = function() {
		return decimalRadixToHex($rootScope.lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId();
	var timer = $interval(function(){
		listener();
	},300);
	timer.then(success, error, notify);
	function success(){
		 // nothing
	}
	function error(){
		 // nothing
	} 
	function notify(){
	  // nothing
	}
	function listener() {
		if($rootScope.Lockset != null && $rootScope.Lockset.refresh) {
			$rootScope.Lockset.refresh = false;
			loadGPS();
		}
	}
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$ionicModal.fromTemplateUrl('pages/common/lastlocation.html', {
	    scope: $scope
	}).then(function(modal) {
	    $scope.modal = modal;
	});
	$scope.saveInstallInfo = function(lockset){
        if (lockset.newDeviceName == null || lockset.newDeviceName == '') {
        	$rootScope.showPopup(constantDefine.input_device);//"请先填写设备名称");
        } else {
        	lockset.deviceName = lockset.newDeviceName; // 将新的设备名称赋值给原有的设备名，保持一致
        	var pubDevice = {
				lockId : lockset.lockId,
				deviceId : lockset.deviceId,
				deviceName : lockset.deviceName,
				location : lockset.location,
				installer : $rootScope.Lockset.installer,
				time : $rootScope.Lockset.time,
				longitude : lockset.longitude,
				latitude : lockset.latitude,
                depend : lockset.depend
			};
        	$scope.saveInstallLockset(pubDevice);
        }
	};
	$scope.saveInstallLockset  = function(device) {
		hlService.home.updateInstallLocksetData().save(device,function(res){
      		if(res.NUM == -1){
      			$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:false});
      		}else{
      			$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:true});
      		}
      	},function(res){
      		$scope.cacheInstallLockset(device);
      	});
	};
	$scope.cacheInstallLockset = function(device) {
		$scope.show();
		blcache.installPubDeviceAndPubLockset(device);
		$scope.hide();
		$state.go('installLocksetResult', {lockId:$rootScope.lockId,success:true});
	};
	$scope.locationHandler = function(Lockset){
		if(Lockset.longitude!="" && Lockset.longitude!=null && Lockset.longitude!=undefined){
			$state.go("locationData",{lng:Lockset.longitude,lat:Lockset.latitude});
		}
		
	};
	$scope.goback = function() {
		$interval.cancel(timer);
		initInstallStatus();
	};
	$scope.setLastLocation = function(lastLoaction) {
		$rootScope.Lockset.longitude  = lastLoaction.longitude;
 	    $rootScope.Lockset.latitude = lastLoaction.latitude;
 	    $rootScope.Lockset.location = lastLoaction.location;
 	    $scope.modal.hide();
	};
	function loadGPS() {
		if ($rootScope.networkState == 'none') {
			$scope.show();
			var posOptions = {timeout: 10000, enableHighAccuracy: false};
		      $cordovaGeolocation.getCurrentPosition(posOptions)
		       .then(function (position) {
		    	   $rootScope.Lockset.latitude  = position.coords.latitude;
		    	   $rootScope.Lockset.longitude = position.coords.longitude;
		    	   $scope.hide();
		       }, function(err) {
		    	   $scope.hide();
				   showLastLocationModal();
		       });
		} else {
			$scope.show();
            CONSTANT.getBaiduMapLocation(function(point){
                if(point){
                    var geoc = new BMap.Geocoder();
                    geoc.getLocation(point, function(rs){
                        var addComp = rs.addressComponents;
                        $rootScope.Lockset.longitude = point.lng;
                        $rootScope.Lockset.latitude = point.lat;
                        $rootScope.Lockset.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
                    });
                    $scope.hide();
                } else {
                    $scope.hide();
                    showLastLocationModal();
                    
                }
            });
//
//			var geolocation = new BMap.Geolocation();
//			geolocation.getCurrentPosition(function(r){
//				if(this.getStatus() == BMAP_STATUS_SUCCESS){
//					var geoc = new BMap.Geocoder();
//					var point = new BMap.Point(r.point.lng,r.point.lat);
//					geoc.getLocation(point, function(rs){
//						var addComp = rs.addressComponents;
//						$rootScope.Lockset.longitude = r.point.lng;
//						$rootScope.Lockset.latitude = r.point.lat;
//						$rootScope.Lockset.location = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
//					});
//					$scope.hide();
//				} else {
//					$scope.hide();
//					showLastLocationModal();
//				}
//			},{enableHighAccuracy: true,timeout: 10000});
		}
	}
	function showLastLocationModal() {
		if (window.localStorage.longitude != null && window.localStorage.longitude != '') {
 		   $scope.lastLocation = {
 			   longitude:   window.localStorage.longitude,
 			   latitude : window.localStorage.latitude,
 			   location : window.localStorage.location  
    	   };
 		   var timer = $timeout(function () {
 			  $scope.modal.show();
           }, 500);
    	   
 	   } else {
 		   $rootScope.showPopup(constantDefine.get_location_error);
 	   }
	}
	function initInstallStatus() {
		$rootScope.Lockset = null;
		$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
		$ionicNavBarDelegate.back();
	}
}]).controller('common.installLocksetResult',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	
	$scope.lockId = $stateParams.lockId;
	$scope.success = $stateParams.success == 'true' ? true : false;
	var getFormatLockId = function() {
		return decimalRadixToHex($rootScope.lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId();
	$scope.goback = function() {
		$rootScope.Lockset = null;
		$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('installLocksetView');
	};
	function refreshAllCache() {
		hlService.user.getPermissionsAndDevicesAndLocksetsByUserId(window.localStorage.userId).get(function(res){
			blcache.refreshAllCache(res);
		},
		function(res){
			// tips:update cache error
			
		});
	}
	refreshAllCache();
}])
.controller('common.recoverLocksetView',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	var timer = $interval(function(){
		listener();
	},300);
	timer.then(success, error, notify);
	function success(){
		 // nothing
	}
	function error(){
		 // nothing
	} 
	function notify(){
	  // nothing
	}
	function listener() {
		if($rootScope.recover != null) {
			$interval.cancel(timer);
			$state.go('recoverLockset');
		}
	}
	$scope.goback = function() {
		$state.go('home');
	};
}])
.controller('common.recoverLockset',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	var getFormatLockId = function(lockId) {
		return decimalRadixToHex(lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId($rootScope.lockId);
	$scope.submitRecoverInfo = function(recover){
		var recover = $rootScope.recover;
		if(recover.lockId == "" || recover.lockId == null){
			return;
		}
		hlService.home.updateRecoverLocksetData().save({
			lockId : recover.lockId,
			deviceId : $rootScope.recover.deviceId,
			deviceName : recover.deviceName,
			location : $rootScope.recover.location,
			installer : 0,
			time : $rootScope.recover.time,
			longitude : 0,
			latitude : 0,
			depend:$rootScope.recover.depend
      	},function(res){
      		if(res.NUM == -1){
      			$state.go('recoverLocksetResult', {lockId:recover.lockId,success:false});
      		}else{
      			$state.go('recoverLocksetResult', {lockId:recover.lockId,success:true});
      		}
      	},function(res){
      		blcache.recoverPubDeviceAndPubLockset(getRecoverLocksetDataCache(recover));
      		$state.go('recoverLocksetResult', {lockId:recover.lockId,success:true});
      	});
	};
	function getRecoverLocksetDataCache(recover) {
		var newRecover = {
			lockId : recover.lockId,
			deviceId : $rootScope.recover.deviceId,
			deviceName : recover.deviceName,
			location : $rootScope.recover.location,
			installer : 0,
			time : $rootScope.recover.time,
			longitude : 0,
			latitude : 0,
			depend:$rootScope.recover.depend
		};
		return newRecover;
	}
	$scope.goback = function() {
		$rootScope.recover = null;
		$ionicNavBarDelegate.back();
	};
}]).controller('common.recoverLocksetResult',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	$scope.lockId = $stateParams.lockId;
	$scope.success = $stateParams.success == 'true' ? true : false;
	var getFormatLockId = function() {
		return decimalRadixToHex($rootScope.lockId);
	};
	var decimalRadixToHex = function(num){
		return num.toString(16);
	};
	$scope.formatLockId = getFormatLockId($rootScope.lockId);
	$scope.goback = function() {
		$rootScope.recover = null;
		$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = true;
    	$state.go('recoverLocksetView');
	};
	function refreshAllCache() {
		hlService.user.getPermissionsAndDevicesAndLocksetsByUserId(window.localStorage.userId).get(function(res){
			blcache.refreshAllCache(res);
		},
		function(res){
			// tips:update cache error
			
		});
	}
	refreshAllCache();
}])
.controller('common.initLocksetDepend0',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	$scope.switchDepend = function() {
		$rootScope.bluetooth.switchDepend = 1;
		$state.go('initLocksetDepend1');
	};
	
}])
.controller('common.initLocksetDepend1',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup', '$ionicNavBarDelegate','hlService','$state', 'blcache',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,$ionicNavBarDelegate,hlService,$state, blcache){
	$scope.switchDepend = function() {
		$rootScope.bluetooth.switchDepend = 0;
		$state.go('initLocksetDepend0');
	};
	
}])
.controller('manage.key',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicPopup,hlService,blcache){
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.blKeyList = [];
	$scope.blkeySearchs = [];
	
	$scope.first = true;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.keyword = null;
	
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadKeyListByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadKeyListByUserId(); 
		}
	};
	$scope.getKeyListByUserId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unblkeymanage);//"当前离线模式下无法进行授权管理");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPubBlKeyListByUserId(window.localStorage.userId,keyWord, $scope.start, $scope.limit).query(function(res){
				$scope.blKeyList = res;
				$scope.$broadcast('scroll.refreshComplete');
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	
	/**
	 * 分页加载
	 * */
	function loadKeyListByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unblkeymanage);//"当前离线模式下无法进行授权管理");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPubBlKeyListByUserId(window.localStorage.userId,keyWord, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							$scope.blKeyList.push(obj);
						}
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	
	
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.blkeySearchs = [];
			var timer = null; 
			hlService.home.getPubBlKeyListByUserId(window.localStorage.userId,keyword, 0, 100).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							$scope.blkeySearchs.push(obj);
						}
					}
					
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		},1000);
		
	}
	
	/**
	 * 获取用户下所在系统下的所有钥匙信息
	 * */
//	$scope.getKeyListByUserId = function(){
//		hlService.home.getPubBlKeyListByUserId(window.localStorage.userId).query(function(res){
//			$scope.blKeyList = res;
//			$scope.$broadcast('scroll.refreshComplete');
//		},function(res){
//			$scope.$broadcast('scroll.refreshComplete');
//		});
//	}
//	$scope.getKeyListByUserId();
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
  	  	$scope.domore = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.blkeySearchs = [];
  	  	$scope.keyword = null;
  	  	$scope.domore = false;
    }
    
//	$scope.doRefresh = function(){
//		$scope.getKeyListByUserId();
//		$scope.$broadcast('scroll.infiniteScrollComplete'); 
//		$scope.domore = true;
//	};
	
	/**
	 * 添加新锁
	 * */
	$scope.addKey = function(){
		$state.go('addKey',{'keyId':-1,'name':'','macAddr':''});
	}
	
	/**
	 * 
	 * */
	$scope.deleteKey = function(key){
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该钥匙?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deletePubBlKey().save(key,function(res){
	    		   	$rootScope.showPopup(res.msg);
	    		   	if(res.msg == "删除成功！"){
	    		   		$scope.getKeyListByUserId();
	    		   		if($scope.isSearch){
		   					$scope.cancelSearch();
		   				}
	    		   	}
	         	});
	       	}
	    });
	}
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addKey',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var id = $stateParams.keyId;
	var name = $stateParams.name;
	var macAddr = $stateParams.macAddr;
	if(id == null || id == undefined){
		$scope.Key = {
			id : -1
		};
	} else {
		$scope.Key = {
			id : id,
			name : name,
			macAddr : macAddr
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.saveBlKeyInfo = function(key){
		
		var pubBlKey = {
			keyId : key.id,
			name : key.name,
			macAddr : key.macAddr,
			sysId : sysId
		}
		
		hlService.home.savePubBlKey().save(pubBlKey,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
		
	};
	
	
})
.controller('manage.device',function($scope,$rootScope,$stateParams,$state,$ionicLoading,$interval,$timeout,$ionicPopup,hlService,blcache){
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.deviceList = [];
	$scope.deviceSearchs = [];
	$scope.keyword = null;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.show = function(){
		$ionicLoading.show({
			templateUrl : 'pages/common/loading.html'
		});
	};
	
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadDeviceListByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadDeviceListByUserId(); 
		}
	};
	
	/**
	 * 获取用户下所有设备信息
	 * 首次加载 0 ~ 20 条
	 * */
	$scope.getDeviceListByUserId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_undevicemanage);//"当前离线模式下无法进行设备管理");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPubDeviceListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				for(var i=0;i<res.length;i++){
					var record = res[i];
					if(record.time != 0){
						record.time = dateFormate(record.time);
					}
					res[i] = record;
				}
				
				$scope.deviceList = res;
				$scope.domore = false;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	/**
	 * 分页加载
	 * */
	function loadDeviceListByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_undevicemanage);//"当前离线模式下无法查看开锁记录");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPubDeviceListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var record = res[i];
							if(record.time != 0){
								record.time = dateFormate(record.time);
							}
							$scope.deviceList.push(record);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.deviceSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		var timer = null; 
				hlService.home.getPubDeviceListBySysId(window.localStorage.sysId,keyword, 0, 100).query(function(res){
					if (res) {
						if (res.length != 0) {
							for(var i=0;i<res.length;i++){
								var record = res[i];
								if(record.time != 0){
									record.time = dateFormate(record.time);
								}
								$scope.deviceSearchs.push(record);
							}
							
						}
						
						timer = $timeout(function () {
			                $scope.$broadcast('scroll.infiniteScrollComplete');  
			            }, 1500);
					} else {
		                $scope.$broadcast('scroll.infiniteScrollComplete');
					}
				},function(res){
					$timeout.cancel(timer);
		            $scope.$broadcast('scroll.infiniteScrollComplete');
				});
				 $scope.$on("$destroy", function () {   
		             $timeout.cancel(timer);  
		        });
	    	}
		},1000);
		
	}

	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
		$scope.domore = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
		$scope.domore = false;
  	  	$scope.deviceSearchs = [];
  	  	$scope.keyword = null;
    }

	/**
	 * 添加新设备
	 * */
	$scope.addDevice = function(){
		$state.go('addDevice',{
			'deviceId' : -1,
			'deviceName' : null,
			'areaId' : null,
			'location' : null
		});
	}
	
	/**
	 * 
	 * */
	$scope.deleteDevice = function(device){
		
		if(device.installer != 0){
			$rootScope.showPopup('设备已上锁，请回收后再进行操作！');
			return;
		}
		
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该设备?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deletePubDevice().save(device.deviceId,function(res){
	   			$rootScope.showPopup(res.msg);
	   			if(res.msg == "删除成功！"){
	   				$scope.getDeviceListByUserId();
	   				if($scope.isSearch){
	   					$scope.cancelSearch();
	   				}
	   			}
	         	});
	       }
	    });
		
		
	}
	
	var dateFormate = function(time){
		var date = new Date(time*1000);
		return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate() + " "
				+ date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
	};
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addDevice',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var deviceId = $stateParams.deviceId;
	var deviceName = $stateParams.deviceName;
	var areaId = $stateParams.areaId;
	var location = $stateParams.location;
	
	if(deviceId == null || deviceId == undefined){
		$scope.Device = {
			deviceId : -1
		};
	} else {
		$scope.Device = {
			'deviceId' : deviceId,
			'deviceName' : deviceName,
			'areaId' : areaId,
			'location' : location
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.savePubDeviceInfo = function(device){
		var areaId = $scope.selectedArea.areaId;
		var pubDevice = {
			deviceId : device.deviceId,
			deviceName : device.deviceName,
			areaId :areaId,
			location : device.location,
			sysId : sysId
		}
		hlService.home.savePubDevice().save(pubDevice,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
		
	};
	
	$scope.loadArea = function(initId){
		hlService.home.getPubAreaDataBySysId(sysId).query(function(res){
			$scope.areaList = res;
			if(initId){
				for(var i=0;i<res.length;i++){
					var record = res[i];
					if(initId == record.areaId){
						$scope.selectedArea = record;
						break;
					}
				}
			} else {
				$scope.selectedArea = res[0];
			}
		},function(res){
			$scope.areaList = [];
		});
	}
	
	$scope.loadArea(areaId);
	
})
.controller('manage.user',function($scope,$rootScope,$ionicPopup,$stateParams,$state,$interval,$timeout,hlService,blcache){
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.teamUserList = [];
	$scope.teamUserSearchs = [];
	/**
	 * 用户新增和编辑时全局班组参数
	 * */
	window.localStorage.selectedUserGroup = '';
	window.localStorage.selectedUserTitle = '';
	
	
	$scope.keyword = null;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.first = true;
	$scope.show = function(){
		$ionicLoading.show({
			templateUrl : 'pages/common/loading.html'
		});
	};
	
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadDeviceListByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadDeviceListByUserId(); 
		}
	};
	
	/**
	 * 获取用户所在系统下所有用户信息
	 * 首次加载 0 ~ 20 条
	 * */
	$scope.getTeamUserListByUserId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unusermanage);//"当前离线模式下无法进行用户管理");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getTeamUserListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				for(var i=0;i<res.length;i++){
					var record = res[i];
					record.formatOpt = $scope.formatOperation(record.opt);
					res[i] = record;
				}
				
				$scope.teamUserList = res;
				$scope.domore = false;
				$scope.$broadcast('scroll.refreshComplete');
				//$scope.hide();
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	/**
	 * 分页加载
	 * */
	function loadDeviceListByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unusermanage);//"当前离线模式下无法进行用户管理");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getTeamUserListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var record = res[i];
							record.formatOpt = $scope.formatOperation(record.opt);
							$scope.teamUserList.push(record);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.teamUserSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		var timer = null; 
				hlService.home.getTeamUserListBySysId(window.localStorage.sysId,keyword, 0, 100).query(function(res){
					if (res) {
						if (res.length != 0) {
							for(var i=0;i<res.length;i++){
								var record = res[i];
								record.formatOpt = $scope.formatOperation(record.opt);
								$scope.teamUserSearchs.push(record);
							}
							
						}
						
						timer = $timeout(function () {
			                $scope.$broadcast('scroll.infiniteScrollComplete');  
			            }, 1500);
					} else {
		                $scope.$broadcast('scroll.infiniteScrollComplete');
					}
				},function(res){
					$timeout.cancel(timer);
		            $scope.$broadcast('scroll.infiniteScrollComplete');
				});
				 $scope.$on("$destroy", function () {   
		             $timeout.cancel(timer);  
		        });
	    	}
		},1000);
		
	}
	
	
	$scope.formatOperation = function(value){
		if(value == "" || value == undefined){
			return "-";
		} else{
			var opts = value.split(",");
			var optFormatter = [];
			for(var i=0;i<opts.length;i++){
				var v = opts[i];
				if(v == 0){
					optFormatter.push("初始化入库");
				} else if(v == 1){
					optFormatter.push("挂锁");
				} else if(v == 2){
					optFormatter.push("开锁维护");
				} else if(v == 3){
					optFormatter.push("锁具回收");
				}
			}
			
			return optFormatter.join("， ");
		}
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
  	  	$scope.domore = false;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.teamUserSearchs = [];
  	  	$scope.domore = true;
  	  	$scope.keyword = null;
    }
	
	/**
	 * 添加新用户
	 * */
	$scope.addUser = function(){
		var user = {
			userId : -1,
			name : null,
			realName : null,
			userGroup : null,
			userTitle : null,
			admin : 0
		}
		$state.go('addUser',{
			'user' : JSON.stringify(user)
		});
	}
	
	/**
	 * 
	 * */
	$scope.deleteUser = function(user){
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该用户?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deleteTeamUser().save(user.userId,function(res){
	   			$rootScope.showPopup(res.msg);
	   			if(res.msg == "删除成功！"){
	   				$scope.getTeamUserListByUserId();
	   				if($scope.isSearch){
	   					$scope.cancelSearch();
	   				}
	   			}
	         	});
	       }
	    });
		
		
	}

	$scope.initUsersPassword = function(user){
		var params = {
			userId : user.userId,
			name : user.name
		};
		var confirmPopup = $ionicPopup.confirm({
			title: '提示',
			template: '此操作会将该用户密码初始化为与账号一致，确定要进行操作吗?',
			cancelText : '取消',
			okText : '确认'
		 });

		 confirmPopup.then(function(res) {
			if(res) {
				hlService.user.initUsersPassword().save(params,function(res){
					
					if(res.status){
						if(user.userId == window.localStorage.userId){ //改当前用户，跳回登录界面
							$state.go("login");
						} else {
							$rootScope.showPopup("初始化成功，注意要及时通知该用户。");
						}
					} else {
						$rootScope.showPopup(res.message);
					}
					

					// if(res.msg == "初始化成功！"){
					// 	$scope.getTeamUserListByUserId();
					// 	if($scope.isSearch){ 
					// 		$scope.cancelSearch();
					// 	}
					// }
				  });
			}
		 });
	}
	
	var dateFormate = function(time){
		var date = new Date(time*1000);
		return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate() + " "
				+ date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
	};
	
	$scope.goBack = function(){
		$state.go('home');
	}
	
})
.controller('manage.addUser',function($scope,$rootScope,$ionicPopup,$stateParams,$state,$interval,$timeout,hlService,blcache,HLVALIDATE){
	$scope.user = JSON.parse($stateParams.user);
	var blKeyList = [];
	$scope.selectedUserGroup = $scope.user.userGroup;
	$scope.selectedUserTitle = $scope.user.userTitle;
	$scope.selectedBlKey = $scope.user.pubBlKey;
	$scope.upName = false;
	if($scope.user.userId != -1){
		$scope.upName = true;
	}
	
	//初始化用户类型
	if($scope.user.admin == 0){
		$scope.userType = false;
	} else { //管理员
		$scope.userType = true;
	}
	
	//初始化操作权限
	opt = $scope.user.opt;
	$scope.selectedCheck = [];
	if(opt){
		if(opt.indexOf(0) != -1){ //初始化入库
			$scope.selectedCheck.push(0);
			$scope.optInit = true;
		} 
		if(opt.indexOf(1) != -1){ //挂锁
			$scope.selectedCheck.push(1);
			$scope.optInstall = true;
		}
		if(opt.indexOf(2) != -1){ //开锁维护
			$scope.selectedCheck.push(2);
			$scope.optOpen = true;
		}
		if(opt.indexOf(3) != -1){ //锁具回收
			$scope.selectedCheck.push(3);
			$scope.optRecover = true
		}
	} else {
		$scope.selectedCheck.push(1);
		$scope.optInstall = true;
		$scope.selectedCheck.push(2);
		$scope.optOpen = true;
		$scope.selectedCheck.push(3);
		$scope.optRecover = true
	}
	
	
	//控制用户类型单选框选择
	$scope.selectedUserType = function(value){
		
		if(value == 1){
			$scope.userType = true;
		} else if(value == 0){
			$scope.userType = false;
		}
	}

	$scope.checkHandler = function(flag,value){
		var hasKey = false;
		for(var i=0; i<$scope.selectedCheck.length; i++){
			var check = $scope.selectedCheck[i];
			if(check == value){
				hasKey = true;
				break;
			}
		}
		if(flag){
			if(!hasKey){
				$scope.selectedCheck.push(value);
			}
		} else {
			if(hasKey){
				$scope.selectedCheck.splice($scope.selectedCheck.indexOf(value), 1);
			}
		}
	}
	var sysId = window.localStorage.sysId;
	$scope.saveTeamUserInfo = function(){
		$scope.user.sysId = sysId;
		//用户名不能为空
		if($scope.user.name == null || $scope.user.name == ''){
			$rootScope.showPopup('请先输入账号!');
			return;
		}

		if( !HLVALIDATE.judge_Account($scope.user.name,"账号") ){
			$rootScope.showPopup(HLVALIDATE.errorMsg);
			return ;
		}
		if($scope.user.realName == null || $scope.user.realName == ''){
			$rootScope.showPopup('请先输入姓名!');
			return;
		}
		if($scope.user.groupId == null || $scope.user.groupId == undefined){
			$rootScope.showPopup('请先选择班组！');
			return;
		}
		if($scope.user.titleId == null || $scope.user.titleId == undefined){
			$rootScope.showPopup('请先选择职务！');
			return;
		}
		if($scope.user.keyId == null || $scope.user.keyId == undefined){
			$rootScope.showPopup('请先选择所持钥匙！');
			return;
		}
		//处理操作权限
		if($scope.selectedCheck.length > 0){
			var optString = $scope.selectedCheck.toString();
			$scope.user.opt = optString;
			delete $scope.user.formatOpt;
		} else {
			$rootScope.showPopup('请选择操作权限!');
			return;
		}
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要保存参数配置?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
			
	    	  hlService.home.saveTeamUserData().save($scope.user,function(res){
	    		  $rootScope.showPopup(res.msg);
	    		  if(res.msg == '保存成功！'){
	    			  $state.go("userManage");
	    		  }
	    	  });
	       }
	    });
		
	};
	
	$scope.showUserGroup = function(){
		$state.go("userGroupList",{'user' : JSON.stringify($scope.user)});
	}
	$scope.showUserTitle = function(){
		$state.go("userTitleList",{'user' : JSON.stringify($scope.user)});
	}
	$scope.showBlKey = function(){
		$state.go("blKeyList",{'user' : JSON.stringify($scope.user)});
	}
	
	$scope.goBack = function(){
		$state.go("userManage");
	}
})
.controller('manage.userGroupList',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var user = JSON.parse($stateParams.user);
	
	if(user != null && user != ''){
		$scope.userGroup = user.userGroup;
	}
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.userGroupList = [];
	$scope.userGroupSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.userGroupSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.userGroupList.length; i++){
	    			var record = $scope.userGroupList[i];
	    			var group = record.description;
	    			if(group.indexOf(keyword) != -1){
	    				$scope.userGroupSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户下所有班组信息
	 * */
	$scope.getUserGroupListBySysId = function(){
		$scope.userGroupList = [];
		hlService.home.getUserGroupBySysId(window.localStorage.sysId).query(function(res){
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if($scope.userGroup && $scope.userGroup.groupId == record.groupId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.userGroupList.push(record);
			}
			
			if($scope.userGroup == null || $scope.userGroup == undefined){
				$scope.userGroupList[0].selected = true;
			}
			
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.userGroupSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getUserGroupListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedGroupItem = function(userGroup){
		for(var i=0; i<$scope.userGroupList.length; i++){
			var record = $scope.userGroupList[i];
			if(userGroup.groupId == record.groupId){
				$scope.userGroupList[i].selected = true;
			} else {
				$scope.userGroupList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.userGroupList.length; i++){
			var record = $scope.userGroupList[i];
			if(record.selected){
				user.userGroup = record;
				delete user.userGroup.selected;
				user.groupId = record.groupId;
			}
		}
		$state.go("addUser",{'user' : JSON.stringify(user)});
	}
	
})
.controller('manage.userTitleList',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var user = JSON.parse($stateParams.user);
	
	if(user != null && user != ''){
		$scope.userTitle = user.userTitle;
	}
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.userTitleList = [];
	$scope.userTitleSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.userTitleSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.userTitleList.length; i++){
	    			var record = $scope.userTitleList[i];
	    			var title = record.description;
	    			if(title.indexOf(keyword) != -1){
	    				$scope.userTitleSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户下所有班组信息
	 * */
	$scope.getUserTitleListBySysId = function(){
		$scope.userTitleList = [];
		hlService.home.getUserTitleBySysId(window.localStorage.sysId).query(function(res){
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if($scope.userTitle && $scope.userTitle.titleId == record.titleId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.userTitleList.push(record);
			}
			
			if($scope.userTitle == null || $scope.userTitle == undefined){
				$scope.userTitleList[0].selected = true;
			}
			
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.userTitleSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getUserTitleListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedTitleItem = function(userTitle){
		for(var i=0; i<$scope.userTitleList.length; i++){
			var record = $scope.userTitleList[i];
			if(userTitle.titleId == record.titleId){
				$scope.userTitleList[i].selected = true;
			} else {
				$scope.userTitleList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.userTitleList.length; i++){
			var record = $scope.userTitleList[i];
			if(record.selected){
				user.userTitle = record;
				delete user.userTitle.selected;
				user.titleId = record.titleId;
			}
		}
		$state.go("addUser",{'user' : JSON.stringify(user)});
	}
	
})
.controller('manage.blKeyList',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var user = JSON.parse($stateParams.user);
	
	if(user != null && user != ''){
		$scope.pubBlKey = user.pubBlKey;
	}
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.blKeyList = [];
	$scope.blKeySearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.blKeySearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.blKeyList.length; i++){
	    			var record = $scope.blKeyList[i];
	    			var macAddr = record.macAddr;
	    			if(macAddr.indexOf(keyword) != -1){
	    				$scope.blKeySearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户下所有班组信息
	 * */
	$scope.getBlKeyListBySysId = function(){
		$scope.blKeyList = [];
		hlService.home.getPubBlKeyListByUserId(window.localStorage.userId, " ", 0, 100).query(function(res){
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if($scope.pubBlKey && $scope.pubBlKey.keyId == record.keyId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.blKeyList.push(record);
			}
			
			if($scope.pubBlKey == null || $scope.pubBlKey == undefined){
				$scope.blKeyList[0].selected = true;
			}
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.blKeySearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getBlKeyListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedBlKeyItem = function(pubBlKey){
		for(var i=0; i<$scope.blKeyList.length; i++){
			var record = $scope.blKeyList[i];
			if(pubBlKey.keyId == record.keyId){
				$scope.blKeyList[i].selected = true;
			} else {
				$scope.blKeyList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.blKeyList.length; i++){
			var record = $scope.blKeyList[i];
			if(record.selected){
				user.pubBlKey = record;
				delete user.pubBlKey.selected;
				delete user.pubBlKey.userId;
				user.keyId = record.keyId;
			}
		}
		$state.go("addUser",{'user' : JSON.stringify(user)});
	}
	
})
.controller('manage.permission',function($scope,$rootScope,$ionicPopup,$stateParams,$state,$interval,$timeout,hlService,blcache){
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.permissionList = [];
	$scope.permissionSearchs = [];
	$scope.domore = false;
	$scope.first = true;
	$scope.start = -1;
	$scope.limit = 20;
	$scope.keyword = null;
	
	$scope.show = function() {
	    $ionicLoading.show({
	    	templateUrl: 'pages/common/loading.html'
	    });
	};
	$scope.hide = function(){
	    $ionicLoading.hide();
	};
	$scope.doRefresh = function() {
		if ($scope.first) {
			timer = $timeout(function () {
				loadPermissionListByUserId(); 
            }, 1000);
			$scope.first = false;
		} else {
			loadPermissionListByUserId(); 
		}
	};
	$scope.getPermissionListBySysId = function(){
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unpermissionmanage);//"当前离线模式下无法进行授权管理");
		} else {
			//$scope.show();
			$scope.start = 0;
			$scope.limit = 20;
			$scope.domore = false;
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPermissionListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				
				for(var i=0;i<res.length;i++){
					var obj = res[i];
					
					obj.startDate = dateFormate(obj.startDate);
					obj.endDate = dateFormate(obj.endDate);
					obj.startTime = timeFormate(obj.startTime);
					obj.endTime = timeFormate(obj.endTime);
					obj.typeDesc = reTypeFormate(obj.type);
					obj.reday = reDayFormate(obj.type,obj.reday);
					res[i] = obj;
				}
				
				$scope.permissionList = res;
				$scope.$broadcast('scroll.refreshComplete');
			},function(res){
				$scope.$broadcast('scroll.refreshComplete');				
			});
		}
		
	};
	
	/**
	 * 分页加载
	 * */
	function loadPermissionListByUserId() {
		if ($rootScope.networkState == 'none') {
			$rootScope.showPopup(constantDefine.offline_unpermissionmanage);//"当前离线模式下无法进行授权管理");
			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.domore = true;  
		} else {
			$scope.start++;
			var timer = null; 
			var keyWord = $scope.keyword == null ? " " : $scope.keyword;
			hlService.home.getPermissionListBySysId(window.localStorage.sysId,keyWord, $scope.start, $scope.limit).query(function(res){
				if (res) {
					if (res.length != 0) {
						for(var i=0;i<res.length;i++){
							var obj = res[i];
							
							obj.startDate = dateFormate(obj.startDate);
							obj.endDate = dateFormate(obj.endDate);
							obj.startTime = timeFormate(obj.startTime);
							obj.endTime = timeFormate(obj.endTime);
							obj.typeDesc = reTypeFormate(obj.type);
							obj.reday = reDayFormate(obj.type,obj.reday);
							$scope.permissionList.push(obj);
						}
						
					}
					if (res.length == 0){
						$scope.domore = true; 
					}
					timer = $timeout(function () {
		                $scope.$broadcast('scroll.infiniteScrollComplete');  
		            }, 1500);
				} else {
					$scope.domore = true;  
	                $scope.$broadcast('scroll.infiniteScrollComplete');
				}
			},function(res){
				$timeout.cancel(timer);
				$scope.domore = true; 
	            $scope.$broadcast('scroll.infiniteScrollComplete');
			});
			 $scope.$on("$destroy", function () {   
	             $timeout.cancel(timer);  
	        });
		}
		
	}
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.permissionSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		
	    		var timer = null; 
				hlService.home.getPermissionListBySysId(window.localStorage.sysId,keyword, 0, 100).query(function(res){
					if (res) {
						if (res.length != 0) {
							for(var i=0;i<res.length;i++){
								var obj = res[i];
								obj.startDate = dateFormate(obj.startDate);
								obj.endDate = dateFormate(obj.endDate);
								obj.startTime = timeFormate(obj.startTime);
								obj.endTime = timeFormate(obj.endTime);
								obj.typeDesc = reTypeFormate(obj.type);
								obj.reday = reDayFormate(obj.type,obj.reday);
								$scope.permissionSearchs.push(obj);
							}
							
						}
						
						timer = $timeout(function () {
			                $scope.$broadcast('scroll.infiniteScrollComplete');  
			            }, 1500);
					} else {
		                $scope.$broadcast('scroll.infiniteScrollComplete');
					}
				},function(res){
					$timeout.cancel(timer);
		            $scope.$broadcast('scroll.infiniteScrollComplete');
				});
				 $scope.$on("$destroy", function () {   
		             $timeout.cancel(timer);  
		        });
	    		
	    	}
		},1000);
		
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.domore = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.domore = false;
  	  	$scope.permissionSearchs = [];
  	  	$scope.keyword = null;
    }
	
	/**
	 * 添加新权限
	 * */
	$scope.addPermission = function(){
		var obj = {
			'id' : -1,
			'userId' : null,
			'deviceId' : null	
		}
		$state.go('addPermission',{'permission' : JSON.stringify(obj)});
	}
	
	/**
	 * 
	 * */
	$scope.deletePermission = function(permission){
		
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该授权关系?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deleteDeviceUserRelations().save(permission.id,function(res){
	   			$rootScope.showPopup(res.msg);
	   			if(res.msg == "删除成功！"){
	   				$scope.getPermissionListBySysId();
	   				
	   				if($scope.isSearch){
	   					$scope.cancelSearch();
	   				}
	   			}
	         	});
	       }
	    });
		
	}
	
	var dateFormate = function(date){
		date = date + " ";
		var year = date.substring(0,4);
		var month = date.substring(4,6);
		var day = date.substring(6,8);
		return year + "-" + month + "-" + day;
	};
	
	var timeFormate = function(time){
		time = time + "";
		
		var len = time.length;
	    while(len < 6) {
	      time = "0" + time;
	      len++;
	    }
	    
		if(time.length == 5){
			var hour = time.substring(0,1);
			var minutes = time.substring(1,3);
			var seconds = time.substring(3,5);
			return hour + ":" + minutes + ":" + seconds;
		}else if(time.length == 6){
			var hour = time.substring(0,2);
			var minutes = time.substring(2,4);
			var seconds = time.substring(4,6);
			return hour + ":" + minutes + ":" + seconds;
		} else{
			return time;
		}
	};
	
	var reTypeFormate = function(type){
		if(type == 0){
			return constantDefine.NO_REPETITION;//"不重复";
		} else if(type == 1){
			return constantDefine.PER_DAY;//"每天";
		} else if(type == 2){
			return constantDefine.PER_WEEK;//"每周";
		} else if(type == 3){
			return constantDefine.PER_MONTH;//"每月";
		}
	};
	
	var reDayFormate = function(type,reDay){
		if(reDay != null){
			if(type == 2){
				var day = ["周日","周一","周二","周三","周四","周五","周六"];
				var reDays = reDay.split(",");
				var format = "";
				for(var i=0;i<reDays.length;i++){
					format += day[reDays[i]] + ",";
				}
				return format.substring(0, format.length-1);
			}else if(type == 3){
				if((reDay.split(",")).length>8){
					var reDays = reDay.split(",");
					var format = "";
					for(var i=0;i<8;i++){
						format += reDays[i] + ",";
					}
					return format+"……";
				}else{
					return reDay + "号";
				}
				
			}
		}else{
			return "";
		}
		
	};
	
	$scope.goBack = function(){
		$state.go("home");
	}
	
})
.controller('manage.addPerm',['$scope','$rootScope','$ionicPopup','$stateParams','$state','$interval','$timeout','hlService','blcache','ionicDatePicker','ionicTimePicker',function($scope,$rootScope,$ionicPopup,$stateParams,$state,$interval,$timeout,hlService,blcache,ionicDatePicker,ionicTimePicker){
	$scope.permission = JSON.parse($stateParams.permission);
	var permissionList = [];
	$scope.id = $scope.permission.id;
	$scope.deviceId = $scope.permission.deviceId;
	$scope.userId = $scope.permission.userId;
	
	var now = new Date();
	var month = now.getMonth()+1;
	if(month < 10){
		month = "0" + month;
	}
	var day = now.getDate();
	if(day < 10){
		day = "0" + day;
	}
	var nowFormateDate = now.getFullYear() + "-" + month + "-" + day;
	if($scope.deviceId == -100){
		$scope.permission.startDate = nowFormateDate;
		$scope.permission.endDate = "2030-12-29";
		$scope.permission.startTime = '0';
		$scope.permission.endTime = "23:59:59";
		$scope.permission.type = 1; //每日重复
		
		
	}
	
	var startInputDate = new Date();
	if($scope.permission.startDate) {
		startInputDate = new Date($scope.permission.startDate);
	}
    var startOption = {
  		weeksList : ['日','一','二','三','四','五','六'],
  		monthsList : ["1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月"],
  		inputDate: startInputDate,      
  		mondayFirst: false,         
  		dateFormat: 'yyyy-MM-dd',
  		closeOnSelect: true,    
  		closeLabel : '关闭',
  		currentYear : (new Date()).getFullYear(),
  		templateType: 'modal',
  		callback: function (val) {
  			var time = new Date(val);
  			var month = time.getMonth()+1;
  			if(month < 10){
  				month = "0" + month;
  			}
  			var day = time.getDate();
  			if(day < 10){
  				day = "0" + day;
  			}
  			var formateDate = time.getFullYear() + "-" + month + "-" + day;
  			
  			if($scope.permission.endDate < formateDate){
  				$rootScope.showPopup("起始日期大于结束日期，请重新选择!");
  			} else {
  				$scope.permission.startDate = formateDate;
  			}
  		}
	};
    
    var endInputDate = new Date();
	if($scope.permission.endDate) {
		endInputDate = new Date($scope.permission.endDate);
	}
	
    var endOption = {
  		weeksList : ['日','一','二','三','四','五','六'],
  		monthsList : ["1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月"],
  		inputDate: endInputDate,      
  		mondayFirst: false,         
  		dateFormat: 'yyyy-MM-dd',
  		closeOnSelect: true,    
  		closeLabel : '关闭',
  		currentYear : (new Date()).getFullYear(),
  		templateType: 'modal',
  		callback: function (val) {
  			var time = new Date(val);
  			var month = time.getMonth()+1;
  			if(month < 10){
  				month = "0" + month;
  			}
  			var day = time.getDate();
  			if(day < 10){
  				day = "0" + day;
  			}
  			var formateDate = time.getFullYear() + "-" + month + "-" + day;
  			
  			if($scope.permission.startDate > formateDate){
  				$rootScope.showPopup("结束日期不能小于起始日期，请重新选择!");
  			} else {
  				$scope.permission.endDate = formateDate;
  			}
  		}
	};
    	      
	//打开时间控件
	$scope.openDatePicker = function(type){
		if($scope.permission.deviceId == -100){
			return;
		}
		if(type == 0){
			ionicDatePicker.openDatePicker(startOption);
		} else if(type == 1){
			ionicDatePicker.openDatePicker(endOption);
		}
	    
	};
	var startHour = 0;
	var startMinutes = 0;
	if($scope.permission.startTime){
		var times = $scope.permission.startTime.split(':');
		startHour = times[0];
		startMinutes = times[1] == null ? 0 : times[1];
	}
	var startTimeOption = {
		inputTime : ((startHour * 60 * 60) + (startMinutes * 60)),
		format : 24,
		step : 5,
		setLabel : '确认',
		closeLabel : '关闭',
		callback : function (val) {      //Mandatory
		      if (typeof (val) != 'undefined') {
		    	  var selectedTime = new Date(val * 1000);
		    	  var hour = selectedTime.getUTCHours();
		    	  if(hour < 10){
		    		  hour = "0" + hour;
		    	  }
		    	  var minutes = selectedTime.getUTCMinutes();
		    	  if(minutes < 10){
		    		  minutes = "0" + minutes;
		    	  }
		    	  if($scope.permission.endTime <= (hour + ":" + minutes + ":00") ){
		    		  $rootScope.showPopup("开始时间不能大于结束时间，请重新选择!");
		    	  } else {
		    		  $scope.permission.startTime = hour + ":" + minutes + ":00";
		    	  }
		      }
		 }
	}
	
	var endHour = 0;
	var endMinutes = 0;
	if($scope.permission.endTime){
		var times = $scope.permission.endTime.split(':');
		endHour = times[0];
		endMinutes = times[1] == null ? '0' : times[1];
	}
	var endTimeOption = {
		inputTime : ((endHour * 60 * 60) + (endMinutes * 60)),
		format : 24,
		step : 5,
		setLabel : '确认',
		closeLabel : '关闭',
		callback : function (val) {      //Mandatory
		      if (typeof (val) != 'undefined') {
		    	  var selectedTime = new Date(val * 1000);
		    	  var hour = selectedTime.getUTCHours();
		    	  if(hour < 10){
		    		  hour = "0" + hour;
		    	  }
		    	  var minutes = selectedTime.getUTCMinutes();
		    	  if(minutes < 10){
		    		  minutes = "0" + minutes;
		    	  }
		    	  if($scope.permission.startTime >= (hour + ":" + minutes + ":00") ){
		    		  $rootScope.showPopup("结束时间不能小于起始时间，请重新选择!");
		    	  } else {
		    		  $scope.permission.endTime = hour + ":" + minutes + ":00";
		    	  }
		      }
		 }
	}
	
	$scope.openTimePicker = function(type){
		if($scope.permission.deviceId == -100){
			return;
		}
		if(type == 0){
			ionicTimePicker.openTimePicker(startTimeOption);
		} else if(type == 1){
			ionicTimePicker.openTimePicker(endTimeOption);
		}
		 
	}
	//类型下拉框常量定义
	$scope.typeList = [
       {id : 0, description : '不重复'},
       {id : 1, description : '每日重复'},
       {id : 2, description : '按周重复'},
       {id : 3, description : '按月重复'}
    ];
	$scope.selectedType = $scope.typeList[0];
	//类型下拉框初始值赋值
	if($scope.permission.type){
		for(var i=0;i<$scope.typeList.length;i++){
			var record = $scope.typeList[i];
			if(record.id == $scope.permission.type){
				$scope.selectedType = record;
				break;
			}
		}
	}
	
	$scope.typeSelectChange = function(selectedType){
		$scope.selectedType = selectedType;
	}
	
	var sysId = window.localStorage.sysId;
	$scope.savePermissionInfo = function(){
		
		//用户名不能为空
		if($scope.permission.device == null || $scope.permission.deviceId == ''){
			$rootScope.showPopup('请先选择设备!');
			return;
		}
		if($scope.permission.teamUser == null || $scope.permission.userId == ''){
			$rootScope.showPopup('请先选择用户!');
			return;
		}
		if($scope.permission.startDate == null || $scope.permission.startDate == undefined){
			$rootScope.showPopup('请先选择起始日期！');
			return;
		}
		if($scope.permission.endDate == null || $scope.permission.endDate == undefined){
			$rootScope.showPopup('请先选择结束日期！');
			return;
		}
		if($scope.permission.startTime == null || $scope.permission.startTime == undefined){
			$rootScope.showPopup('请先选择开始时间！');
			return;
		}
		if($scope.permission.endTime == null || $scope.permission.endTime == undefined){
			$rootScope.showPopup('请先选择结束时间！');
			return;
		}
		
		//处理重复类型
		if($scope.selectedType){
			$scope.permission.type = $scope.selectedType.id;
			delete $scope.permission.typeDesc;
		} else {
			$rootScope.showPopup('请先选择重复类型!');
			return;
		}
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要保存参数配置?',
	       cancelText : '取消',
	       okText : '确认'
	    });
		
		//根据实体类添加响应参数
		$scope.permission.operator = window.localStorage.userId;
		$scope.permission.optTime = (new Date()).getTime()/1000;
		
		
	    confirmPopup.then(function(res) {
	       if(res) {
	    	  var permissionObj = $scope.permission;
	    	  permissionObj.startDate = permissionObj.startDate.replace(/-/g,'');
	    	  permissionObj.endDate = permissionObj.endDate.replace(/-/g,'');
	    	  permissionObj.startTime = permissionObj.startTime.replace(/:/g,'');
	    	  permissionObj.endTime = permissionObj.endTime.replace(/:/g,'');
	    	  
	    	  hlService.home.savePermissionData().save(permissionObj,function(res){
	    		  $rootScope.showPopup(res.msg);
	    		  if(res.msg == '保存成功！'){
	    			  $state.go("permissionManage");
	    		  }
	    	  });
	       }
	    });
	};
	
	$scope.showPermDevice = function(val){
		$state.go("selectDeviceList",{'permission' : JSON.stringify($scope.permission)});
	}
	
	$scope.showPermUser = function(val){
		$state.go("selectUserList",{'permission' : JSON.stringify($scope.permission)});
	}
	
	$scope.goBack = function(){
		$state.go("permissionManage");
	}
	
}]).controller('manage.selectDevice',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var permission = JSON.parse($stateParams.permission);
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.deviceList = [];
	$scope.deviceSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.deviceSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.deviceList.length; i++){
	    			var record = $scope.deviceList[i];
	    			var devName = record.deviceName;
	    			if(devName.indexOf(keyword) != -1){
	    				$scope.deviceSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户所在系统下所有设备信息
	 * */
	$scope.getDeviceListBySysId = function(){
		$scope.deviceList = [];
		hlService.home.getPubDeviceListBySysId(window.localStorage.sysId," ",0,500).query(function(res){
			var all = {
				'deviceId' : -100,
				'deviceName' : '全部设备',
				'location' : '选择此项拥有所有设备的操作权限',
				
			}
			$scope.deviceList.push(all);
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if(permission.deviceId && permission.deviceId == record.deviceId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.deviceList.push(record);
			}
			if(permission.device == undefined || permission.deviceId == null){
				$scope.deviceList[0].selected = true;
			}
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.deviceSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getDeviceListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedDeviceItem = function(device){
		for(var i=0; i<$scope.deviceList.length; i++){
			var record = $scope.deviceList[i];
			if(device.deviceId == record.deviceId){
				$scope.deviceList[i].selected = true;
			} else {
				$scope.deviceList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.deviceList.length; i++){
			var record = $scope.deviceList[i];
			if(record.selected){
				permission.device = record;
				delete permission.device.selected;
				permission.deviceId = record.deviceId;
			}
		}
		$state.go("addPermission",{'permission' : JSON.stringify(permission)});
	}
	
}).controller('manage.selectUser',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var permission = JSON.parse($stateParams.permission);
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.teamUserList = [];
	$scope.teamUserSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.teamUserSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.teamUserList.length; i++){
	    			var record = $scope.teamUserList[i];
	    			var userName = record.name;
	    			if(userName.indexOf(keyword) != -1){
	    				$scope.teamUserSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
	}
	
	/**
	 * 获取用户所在系统下所有用户信息
	 * */
	$scope.getTeamUserListBySysId = function(){
		$scope.teamUserList = [];
		hlService.home.getTeamUserListBySysId(window.localStorage.sysId," ",0,500).query(function(res){
			for(var i=0; i<res.length; i++){
				var record = res[i];
				if(permission.userId && permission.userId == record.userId){
					record.selected = true;
				} else {
					record.selected = false;
				}
				$scope.teamUserList.push(record);
			}
			if(permission.teamUser == undefined || permission.userId == null){
				$scope.teamUserList[0].selected = true;
			}
			$scope.$broadcast('scroll.refreshComplete');
			
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.teamUserSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getTeamUserListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	
	$scope.selectedTeamUserItem = function(teamUser){
		for(var i=0; i<$scope.teamUserList.length; i++){
			var record = $scope.teamUserList[i];
			if(teamUser.userId == record.userId){
				$scope.teamUserList[i].selected = true;
			} else {
				$scope.teamUserList[i].selected = false;
			}
		}
	}
	
	$scope.saveSelectedInfo = function(){
		for(var i=0; i<$scope.teamUserList.length; i++){
			var record = $scope.teamUserList[i];
			if(record.selected){
				permission.teamUser = record;
				delete permission.teamUser.selected;
				permission.userId = record.userId;
			}
		}
		$state.go("addPermission",{'permission' : JSON.stringify(permission)});
	}
	
})

.controller('manage.area',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicPopup,hlService,blcache){
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.areaList = [];
	$scope.areaSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.areaSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.areaList.length; i++){
	    			var record = $scope.areaList[i];
	    			var description = record.description;
	    			if(description.indexOf(keyword) != -1){
	    				$scope.areaSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
		
	}
	
	/**
	 * 获取用户下所在系统下的所有钥匙信息
	 * */
	$scope.getAreaListBySysId = function(){
		$scope.areaList = [];
		hlService.home.getPubAreaDataBySysId(window.localStorage.sysId).query(function(res){
			$scope.areaList = res;
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	$scope.getAreaListBySysId();
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.areaSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getAreaListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	/**
	 * 添加新区域
	 * */
	$scope.addArea = function(){
		$state.go('addArea',{'areaId':-1,'description':''});
	}
	
	/**
	 * 
	 * */
	$scope.deleteArea = function(area){

		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该区域?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deletePubAreaData().save(area.areaId,function(res){
	    		   	$rootScope.showPopup(res.msg);
	    		   	if(res.msg == "删除成功！"){
	    		   		$scope.getAreaListBySysId();
	    		   		if($scope.isSearch){
		   					$scope.cancelSearch();
		   				}
	    		   	}
	         	});
	       	}
	    });
	}
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addArea',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var areaId = $stateParams.areaId;
	var description = $stateParams.description;
	if(areaId == null || areaId == undefined){
		$scope.area = {
			areaId : -1
		};
	} else {
		$scope.area = {
			areaId : areaId,
			description : description
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.saveAreaInfo = function(area){
		area.sysId = sysId;
		hlService.home.savePubArea().save(area,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
	};
})

.controller('manage.group',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicPopup,hlService,blcache){
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.groupList = [];
	$scope.groupSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.groupSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.groupList.length; i++){
	    			var record = $scope.groupList[i];
	    			var description = record.description;
	    			if(description.indexOf(keyword) != -1){
	    				$scope.groupSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
		
	}
	
	/**
	 * 获取用户下所在系统下的所有钥匙信息
	 * */
	$scope.getGroupListBySysId = function(){
		hlService.home.getUserGroupBySysId(window.localStorage.sysId).query(function(res){
			$scope.groupList = res;
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	$scope.getGroupListBySysId();
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.groupSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getGroupListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	/**
	 * 添加新锁
	 * */
	$scope.addGroup = function(){
		$state.go('addGroup',{'groupId':-1,'description':''});
	}
	
	/**
	 * 
	 * */
	$scope.deleteGroup = function(group){
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该班组?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deleteUserGroupData().save(group.groupId,function(res){
	    		   	$rootScope.showPopup(res.msg);
	    		   	if(res.msg == "删除成功！"){
	    		   		$scope.getGroupListBySysId();
	    		   		if($scope.isSearch){
		   					$scope.cancelSearch();
		   				}
	    		   	}
	         	});
	       	}
	    });
	}
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addGroup',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var groupId = $stateParams.groupId;
	var description = $stateParams.description;
	if(groupId == null || groupId == undefined){
		$scope.group = {
			groupId : -1
		};
	} else {
		$scope.group = {
			groupId : groupId,
			description : description
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.saveUserGroupInfo= function(group){
		group.sysId = sysId;
		hlService.home.saveUserGroup().save(group,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
	};
})

.controller('manage.title',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,$ionicPopup,hlService,blcache){
	
	$scope.domore = false;
	$scope.hideDataForLikeSearch = false;
	$scope.isSearch = false;
	$scope.titleList = [];
	$scope.titleSearchs = [];
	
	/**
	 * 搜索框搜索监听
	 * */
	$scope.inputHandler = function(keyword){
		$scope.timeout = $timeout(function(){
			$scope.titleSearchs = [];
			if(keyword != null && keyword != undefined){
	    		$scope.isSearch = true;
	    		for(var i=0; i<$scope.titleList.length; i++){
	    			var record = $scope.titleList[i];
	    			var description = record.description;
	    			if(description.indexOf(keyword) != -1){
	    				$scope.titleSearchs.push(record);
	    			}
	    		}
	    	}
		},1000);
		
	}
	
	/**
	 * 获取用户下所在系统下的所有钥匙信息
	 * */
	$scope.getTitleListBySysId = function(){
		hlService.home.getUserTitleBySysId(window.localStorage.sysId).query(function(res){
			$scope.titleList = res;
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	$scope.getTitleListBySysId();
	/**
	 * 输入框获取焦点隐藏列表
	 * */
	$scope.hideData = function() {
  	  	$scope.hideDataForLikeSearch = true;
  	  	$scope.isSearch = true;
    };
    /**
     * 取消搜索
     * */
    $scope.cancelSearch = function(){
    	$scope.hideDataForLikeSearch = false;
  	  	$scope.isSearch = false;
  	  	$scope.titleSearchs = [];
  	  	$scope.keyword = null;
    }
    
	$scope.doRefresh = function(){
		$scope.getTitleListBySysId();
		$scope.$broadcast('scroll.infiniteScrollComplete'); 
		$scope.domore = true;
	};
	
	/**
	 * 添加新锁
	 * */
	$scope.addTitle = function(){
		$state.go('addTitle',{'titleId':-1,'description':''});
	}
	
	/**
	 * 
	 * */
	$scope.deleteTitle = function(title){
		var confirmPopup = $ionicPopup.confirm({
	       title: '提示',
	       template: '确定要删除该职务?',
	       cancelText : '取消',
	       okText : '确认'
	    });
	    confirmPopup.then(function(res) {
	       if(res) {
	    	   hlService.home.deleteUserTitleData().save(title.titleId,function(res){
	    		   	$rootScope.showPopup(res.msg);
	    		   	if(res.msg == "删除成功！"){
	    		   		$scope.getTitleListBySysId();
	    		   		if($scope.isSearch){
		   					$scope.cancelSearch();
		   				}
	    		   	}
	         	});
	       	}
	    });
	}
	
	$scope.goBack = function(){
		$state.go('home');
	}
})
.controller('manage.addTitle',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	var titleId = $stateParams.titleId;
	var description = $stateParams.description;
	if(titleId == null || titleId == undefined){
		$scope.title = {
			titleId : -1
		};
	} else {
		$scope.title = {
			titleId : titleId,
			description : description
		};
	}
	var sysId = window.localStorage.sysId;
	$scope.saveTitleInfo = function(title){
		
		title.sysId = sysId;
		
		hlService.home.saveUserTitle().save(title,function(res){
			$rootScope.showPopup(res.msg);
			if(res.msg == "保存成功！"){
				history.go(-1);
			}
      	});
		
	};
}).controller('common.forget',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,blcache){
	
$scope.nameErrLog = null;
	$scope.errLog = null;
	$scope.repassErrLog = null;

	$scope.valideUsername = function(username){
		if( !HLVALIDATE.judge_Account(username,"用户名") ){
			
			$scope.nameErrLog = HLVALIDATE.errorMsg;
			$scope.errLog = null;
			$scope.repassErrLog = null;
			return false;
		}

		return true;
	}
	$scope.validePassword = function(password){
		
		if( !HLVALIDATE.judge_Account(password,"新密码") ){
			if($scope.nameErrLog == null){
				$scope.errLog = HLVALIDATE.errorMsg;
				$scope.repassErrLog = null;
			}
			return false;
		}

		return true;
	};

	$scope.valideRepassword = function(password,repassword){
		if(repassword != password){
			if($scope.nameErrLog == null && $scope.errLog == null){
				$scope.repassErrLog = "确认密码与新密码不一致。";
			}
			
			return false;
		}

		return true;
	};

	$scope.resetValideMsg = function(type){
		if(type == 0){
			$scope.nameErrLog = null;
		} else if(type == 1){
			$scope.errLog = null;
		} else if(type == 2){
			$scope.repassErrLog = null;
		} else {

		}
		
		
	}

	$scope.submitResetData = function(username,password,repassword){
		
		if(!$scope.valideUsername(username) || !$scope.validePassword(password) || !$scope.valideRepassword(password,repassword)){
			return;
		}
		
		var params = {
			name : username,
			password : hex_md5(password)
		};
		
		 //修改密码
		 hlService.user.resetPasswordByName().save(params,function(res){
			
			if(res.status){
				
				$state.go("login");
			} else {
				$scope.errLog = res.message;
			}
			
		},function(error){
			CONSTANT.msgShow("网络好像失联了。");
			
		});
		
	}

	$scope.goback = function() {
		$state.go('login');
	};


}).controller('common.resetPassword',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService,HLVALIDATE,CONSTANT){

	$scope.oldPasErrLog = null;
	$scope.errLog = null;
	$scope.repassErrLog = null;

	$scope.valideUsername = function(username){
		if( !HLVALIDATE.judge_Account(username,"用户名") ){
			
			$scope.oldPasErrLog = HLVALIDATE.errorMsg;
			$scope.errLog = null;
			$scope.repassErrLog = null;
			return false;
		}

		return true;
	}
	$scope.validePassword = function(oldPassword,password){
		if(oldPassword == null || oldPassword == undefined || oldPassword == ""){
			$scope.oldPasErrLog = "请先输入旧密码。";
			$scope.errLog = null;
			$scope.repassErrLog = null;
			return false;
		}
		if(oldPassword == password){
			if($scope.oldPasErrLog == null){
				$scope.errLog = "新密码不能与旧密码相同";
				$scope.repassErrLog = null;
			}
			return false;
		}
		
		if( !HLVALIDATE.judge_Account(password,"新密码") ){
			if($scope.oldPasErrLog == null){
				$scope.errLog = HLVALIDATE.errorMsg;
				$scope.repassErrLog = null;
			}
			return false;
		}
		return true;
	};

	$scope.valideRepassword = function(password,repassword){
		if(repassword != password){
			if($scope.oldPasErrLog == null && $scope.errLog == null){
				$scope.repassErrLog = "确认密码与新密码不一致。";
			}
			
			return false;
		}

		return true;
	};

	$scope.resetValideMsg = function(type){
		if(type == 0){
			$scope.oldPasErrLog = null;
		} else if(type == 1){
			$scope.errLog = null;
		} else if(type == 2){
			$scope.repassErrLog = null;
		} else {

		}
		
		
	}

	$scope.submitResetData = function(oldPassword,password,repassword){
		if(!$scope.validePassword(oldPassword,password) || !$scope.valideRepassword(password,repassword)){
			return;
		}
		if ($rootScope.networkState == 'none') {
			$scope.$broadcast('scroll.refreshComplete');
			$rootScope.showPopup(constantDefine.offline_unusermanage);//"当前离线模式下无法进行用户管理");
			return;
		}
		
		var params = {
			name : window.localStorage.userName,
			oldPassword :  hex_md5(oldPassword),
			password : hex_md5(password),
			sysId : window.localStorage.sysId
		};
		
		 //修改密码
		 hlService.user.updatePasswordByOldPassword().save(params,function(res){
			
			if(res.status){
				
				$state.go("login");
			} else {
				$scope.errLog = res.message;
			}
			
		},function(error){
			CONSTANT.msgShow("网络好像失联了。");
			
		});
		
	}

	$scope.goback = function() {
		$state.go('home');
	};


});
