angular.module('btapp.controllers', [])
.controller('common.login',function($scope,$rootScope,$cordovaToast,$stateParams,$state,$ionicPopup,
		$cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $timeout, hlService){
	if(window.localStorage.userName!=null){
		$scope.user={
			username:window.localStorage.userName,
			password:window.localStorage.password
		}
	}
	if(window.localStorage.hisData == null){
		window.localStorage.hisData = '[]';
	}
	if(window.localStorage.lockInstallData == null){
		window.localStorage.lockInstallData = '[]';
	}
	if(window.localStorage.recoverData == null){
		window.localStorage.recoverData = '[]';
	}
	
	
	
	
/**
 * 本控制器中注释代码为报文交互过程跟踪日志代码
 * 全部释放后会生成日志文件可跟踪查询
 * 请勿删除 
 * leaf
 * */	
//$rootScope.fileName = "bltoothLog.txt";
//$rootScope.fileURL = cordova.file.externalRootDirectory;
//createFile($rootScope.fileName);
	


	function createFile(fileName){
		var dateTime = new Date();
		var m = (dateTime.getMonth()+1) < 10 ? '0'+(dateTime.getMonth()+1) : (dateTime.getMonth()+1);
    	var d = dateTime.getDate() < 10 ? '0'+ dateTime.getDate() : dateTime.getDate();
    	var h = dateTime.getHours() < 10 ? '0' + dateTime.getHours() : dateTime.getHours();
    	var min = dateTime.getMinutes() < 10 ? '0' + dateTime.getMinutes() : dateTime.getMinutes();
    	var s = dateTime.getSeconds() < 10 ? '0' + dateTime.getSeconds() : dateTime.getSeconds();
		var timeFormate = dateTime.getFullYear()+"-"+m+"-"+d+" "
						+ h + ":" + min + ":" + s;
		var datas = "日志文件创建：" + timeFormate;
    	$cordovaFile.writeFile(cordova.file.externalRootDirectory, fileName,datas, true);
    	
	}
	
	$rootScope.writeFile = function(path,file,data){
		$cordovaFile.writeExistingFile(path, file, data);
	}
	

	/**
	 * 登录按钮监听
	 * */
    $scope.signIn = function(user) {
		$rootScope.showPopup = function(popupText) {
	        // 自定义弹窗
	        var myPopup = $ionicPopup.show({
	        	title : '提示',
	            template: popupText,
	            scope: $rootScope
	        });
	        $timeout(function() {
	           myPopup.close(); // 3秒后关闭弹窗
	        }, 3000);
	    };
	    
    	hlService.user.login().save({
      		name:user.username, 
      		password:hex_md5(user.password) 
      	},
      	function(res){
	    	if (res.login) {
    			window.localStorage.userName = res.name; //用户名
    			window.localStorage.password = user.password; //密码
    			window.localStorage.userId = res.userId; //用户id
    			window.localStorage.groupId = res.grpId;
    			window.localStorage.keyName = res.keyMacAddr; //蓝牙钥匙连接名
    			window.localStorage.lockPerm = JSON.stringify(res.permission); //权限信息
    			window.localStorage.opt = res.opt; //用户配置下功能按钮权限
    			window.localStorage.locksets = JSON.stringify(res.locksets); //用户下锁具信息
    			var blueService = {
					'service_uuid':'f000c0e0-0451-4000-b000-000000000000',
					'notifyCharacteristic_uuid':'f000c0e1-0451-4000-b000-000000000000',
					'characteristic_uuid':'f000c0e2-0451-4000-b000-000000000000'
				};
				window.localStorage.service = JSON.stringify(blueService);
				$scope.keyName = res.keyMacAddr;
			    $scope.service = blueService;
			    $rootScope.lockPerm = res.permission;
			    
			    //保存离线状态下开锁历史数据信息
			    if(window.localStorage.hisData){
			    	var hisRecords = JSON.parse(window.localStorage.hisData);
			    	if(hisRecords.length !=0){
				    	hlService.home.savePubHisDataList().save(hisRecords,function(res){
				    		$rootScope.showPopup("开锁数据同步成功。");
				    		window.localStorage.hisData = '[]';
			          	});
				    }
			    }
			    //保存离线状态下锁具回收数据信息
			    if(window.localStorage.recoverData){
			    	var recoverRecords = JSON.parse(window.localStorage.recoverData);
			    	if(recoverRecords.length != 0){
			    		hlService.home.updateRecoverLocksetDataList().save(recoverRecords,function(res){
				    		$rootScope.showPopup("锁回收数据同步成功。");
				    		window.localStorage.recoverData = '[]';
			          	});
			    	}
			    }
			    //保存离线状态下锁具安装定位信息
			    if(window.localStorage.lockInstallData){
			    	var lockInstallRecords = JSON.parse(window.localStorage.lockInstallData);
			    	if(lockInstallRecords.length != 0){
			    		
			    		var geolocation = new BMap.Geolocation();
		    			geolocation.getCurrentPosition(function(r){
		    				if(this.getStatus() == BMAP_STATUS_SUCCESS){
		    					var longitude = r.point.lng;
		    					var latitude = r.point.lat;
		    					for(var i=0;i<lockInstallRecords.length;i++){
		    						var record = lockInstallRecords[i];
		    						record.longitude = longitude;
		    						record.latitude = latitude;
		    						lockInstallRecords[i] = record;
		    					}
		    					hlService.home.savePubDeviceDataList().save(lockInstallRecords,function(res){
					    			$rootScope.showPopup("锁具安装数据同步成功。");
					    			window.localStorage.lockInstallData = '[]';
					          	});
		    					
		    				} else {
		    					$rootScope.showPopup("地址定位失败：" + this.getStatus());
		    				}        
		    			},{enableHighAccuracy: true});
			    	}
			    }
			    $rootScope.bluetooth = new BluetoothFactory();
			    $rootScope.bluetooth.setOnline(true);
    			$state.go('home');
	    	} else {
	    		$scope.errMsg = '用户名或密码错误！';
	    		$state.go('login');
	    	}
      },function(res){
    	 
		  var blueService = {
			 'service_uuid':'f000c0e0-0451-4000-b000-000000000000',
			 'notifyCharacteristic_uuid':'f000c0e2-0451-4000-b000-000000000000',
			 'characteristic_uuid':'f000c0e1-0451-4000-b000-000000000000'
		  };
		    
    	  if(user.username == window.localStorage.userName && user.password == window.localStorage.password){
    		  $scope.keyName = window.localStorage.keyName;
    		  $scope.service = blueService;
    		  $rootScope.lockPerm = window.localStorage.lockPerm; 
    		  
    		  $rootScope.bluetooth = new BluetoothFactory();
			  $rootScope.bluetooth.setOnline(false);
    		  $state.go("home");
    	  }else{
    		  $state.go("login");
    	  }
      });
    };
    
    var BluetoothFactory = function(){
		var Bluetooth = {
	    	/**
    		 * 是否进行蓝牙扫描
    		 * */
	    	scanFlag : true,
	    	/**
	    	 * 是否网络在线
	    	 * */
	    	online : true, 
	    	connected : false, //蓝牙是否连接过
	    	isInstalling : false,//是否为挂锁模式
	    	isInit : false, //是否初始化入库模式
	    	isMain : true, //是否维护模式
	    	isReturn : false,//是否回收模式
	    	key : "00 01 02 03 04 05 06 07",//异或校验算法钥匙信息
	    	setOnline : function(isOnline){
	    		this.online = isOnline;
	    	},
		    scanDevice : function(){
		    	if(!this.online){
		    		$cordovaToast.showShortCenter("网络偷懒啦，转离线模式。");
		    	}
		    	
		    	ble.scan([], 5, this.onScanDevice, this.onError);
		    },
		    
		    onScanDevice : function(device){
		    	if(device.name == $scope.keyName){
		    		$rootScope.bluetooth.deviceId = device.id;
		    		$rootScope.bluetooth.connect();
		    	}
		    },
		    
		    onError : function(reason){
		    	$rootScope.status += "(通信出错)";
		    	//$rootScope.bluetooth.disconnect();
		    },
		    
		    connect: function() {
		        ble.connect(this.deviceId, this.onConnect, this.onError);
		    },
		    /**
			 * 蓝牙通讯连接后启动通道监听
			 * */
			onConnect : function(peripheral){
				$rootScope.bluetooth.determineServiceType(peripheral);
				ble.startNotification($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.notifyCharacteristicUUID, $rootScope.bluetooth.onData, $rootScope.bluetooth.onError);
				$rootScope.status = "已连接";
			},
			/**
			 * 通道信息解析
			 * */
			determineServiceType: function(peripheral) {
				peripheral.characteristics.filter(function(element) {
					var properties = element.properties;
					for(var i=0;i<properties.length;i++){
						var prop = properties[i];
						if("notify" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.notifyCharacteristicUUID = element.characteristic;
						} else if("write" == prop.toLowerCase()){
							$rootScope.bluetooth.serviceUUID = element.service;
							$rootScope.bluetooth.characteristicUUID = element.characteristic;
						}
					}
					if($rootScope.bluetooth.notifyCharacteristicUUID && $rootScope.bluetooth.characteristicUUID){
						return;
					}
		        })[0];
		    },
			/**
			 * 通知监听处理
			 * */
		    onData : function(buffer){
		    	$rootScope.bluetooth.parseResult($rootScope.bluetooth.bytesToString(buffer));
		    },
		    /**
		     * 参数： 十六进制数
		     * 异或校验运算 结果返回十进制数
		     * */
		    XorCheck : function(Data,Length){
	    	    var sum=0,i;
	    	    for(var i=0; i<Length; i++)
	    	    {
	    	        sum ^= Data[i]; 
	    	    }
	    	    return sum;
	    	},
	    	/**
	    	 * 参数： 十六进制数
	    	 * 加密算法  结果返回十进制数
	    	 * */
		    HloveyRC4 : function(aInput, aKey) {
		    	var iS = new Uint8Array(256);
	    	    var iK = new Uint8Array(256);
	    	    for (var i = 0; i < 256; i++)
	    	        iS[i] = i;
	    	    var j = 1;
	    	    for (var i = 0; i < 256; i++){
	    	        iK[i] = aKey[(i % aKey.length)];
	    	    }
	    	    j = 0;
	    	    for (var i = 0; i < 256; i++) {
	    	        j = (j + iS[i]&0xff + iK[i]&0xff) % 256;
	    	        var temp = iS[i];
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	    }
	    	    var i = 0;
	    	    j = 0;
	    	    var iOutputChar = new Uint8Array(aInput.length);
	    	    for (var x = 0; x < iOutputChar.length; x++) {
	    	        i = (i + 1) % 256;
	    	        j = (j + iS[i]&0xff) % 256;
	    	        var temp = iS[i]&0xff;
	    	        iS[i] = iS[j];
	    	        iS[j] = temp;
	    	        var t = (iS[i] + (iS[j]&0xff % 256)) % 256;
	    	        var iY = iS[t]&0xff;
	    	        var iCY =  iY;
	    	        iOutputChar[x] = aInput[x] ^ iCY;
	    	    }
	    	    return iOutputChar;
			},
			/**
			 * 参数：ArrayBuffer
			 * 结果：十进制转十六进制
			 * */
		    bytesToString : function(buffer) {
		    	var a = new Uint8Array(buffer);
				 var data = [];
				 for(var i=0;i<a.length;i++){
					 data[i] = $rootScope.bluetooth.decimalRadixToHex(a[i]);
				 }
				 return data;
			},
			/**
			 * 参数：十六进制参数字符串，已空格分开
			 * 结果：无符号十六进制数数组
			 * */
			stringToBytes : function(string) {
				 var arr = string.split(" ");
				 var array = new Uint8Array(arr.length);
				 for (var i = 0; i < arr.length;i++) {
					 array[i] = '0x' + arr[i];
				 }
				 return array;
			},
			/**
			 * 十六进制转十进制数
			 * 参数：十六进制数
			 * 结果：十进制数
			 * */
			hexRadixToDecimal : function(num){
				return parseInt(num, 16);
			},
			/**
			 * 十进制数转十六进制数
			 * 参数：十进制数
			 * 结果：十六进制数
			 * */
			decimalRadixToHex : function(num){
				return num.toString(16);
			},
			
			/**
			 * 安装锁具地址信息获取操作
			 * */
			installLock : function(installTime,timeFormate){
				if(this.online){
					var geolocation = new BMap.Geolocation();
	    			geolocation.getCurrentPosition(function(r){
	    				if(this.getStatus() == BMAP_STATUS_SUCCESS){
	    					var geoc = new BMap.Geocoder();  
	    					var point = new BMap.Point(r.point.lng,r.point.lat);
	    					geoc.getLocation(point, function(rs){
	    						var addComp = rs.addressComponents;
	    						
		    					$rootScope.Lockset = {
		    						lockId : $rootScope.lockId,
		    						installer : window.localStorage.userId,
		    						installName : window.localStorage.userName,
		    						time : installTime,
		    						timeFormate : timeFormate,
		    						longitude : r.point.lng,
		    						latitude : r.point.lat,
		    						location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
		    					}
	    					});
	    				} else {
	    					$rootScope.showPopup("地址定位失败：" + this.getStatus());
	    				}        
	    			},{enableHighAccuracy: true});
				} else {
					$rootScope.Lockset = {
						lockId : $rootScope.lockId,
						installer : window.localStorage.userId,
						installName : window.localStorage.userName,
						time : installTime,
						timeFormate : timeFormate
						//longitude : r.point.lng,
						//latitude : r.point.lat,
						//location : addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber
					}
				}
			},
			/**
			 * 回收锁具参数设置
			 * */
			setRecoverParams : function(res){
				var device = res.device;
    			var time = res.device["time"] * 1000;
				var dateTime = new Date(time);
				var m = (dateTime.getMonth()+1) < 10 ? '0'+(dateTime.getMonth()+1) : (dateTime.getMonth()+1);
		    	var d = dateTime.getDate() < 10 ? '0'+ dateTime.getDate() : dateTime.getDate();
		    	var h = dateTime.getHours() < 10 ? '0' + dateTime.getHours() : dateTime.getHours();
		    	var min = dateTime.getMinutes() < 10 ? '0' + dateTime.getMinutes() : dateTime.getMinutes();
		    	var s = dateTime.getSeconds() < 10 ? '0' + dateTime.getSeconds() : dateTime.getSeconds();
				var timeFormate = dateTime.getFullYear()+"-"+m+"-"+d+" "
								+ h + ":" + min + ":" + s;
				
				$rootScope.recover = {
					lockId : $rootScope.lockId,
					deviceId : device.deviceId,
					deviceName : device.deviceName,
					installer : device.installer,
					installName : device.installUser.name,
					time : device.time,
					timeFormate : timeFormate,
					longitude : device.longitude,
					latitude : device.latitude,
					location : device.location
				}
			},
			/**
			 * 接收报文解析
			 * */
		    parseResult : function(result){
		    	var that = this;
		    	if(result[0] == 6){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n接收到报文—— (1)");
		    		var dataLength = parseInt(result[1]);//报文数据长度
		    		var bwDatas = [];
		    		for(var i=0;i<dataLength;i++){
		    			var bwData = result[i+2];
		    			bwDatas.push(bwData);  //十六进制数据位
		    		}
		    		var secretData = that.HloveyRC4(that.stringToBytes(bwDatas.join(" ")), that.stringToBytes(that.key));
		    		var secretCheck = that.XorCheck(secretData.subarray(0,secretData.length-1), secretData.length-1);
		    		var newSecretData = new Uint8Array(secretData.length + 1);
		    		secretData[secretData.length-1] = secretCheck; //修改最后一位值为校验位的值{0:248,1:246,2:249,3:244,4:230,5:229}
		    		var sendDataInfo = [04,05]; //发送数据
		    		for(var i=0;i<secretData.length;i++){
		    			var d = secretData[i].toString(16);
		    			sendDataInfo[i+2] = d;
		    		}
		    		var j = 2 + dataLength;
		    		var checkData = result[j]; //校验位16进制
		    		var judgeCheck = that.XorCheck(that.stringToBytes(bwDatas.join(" ")), bwDatas.length); //十进制
		    		if(that.decimalRadixToHex(judgeCheck) != checkData){
		    			$rootScope.showPopup("报文数据校验位不一致，操作终止!!!");
		    		} else {
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n校验位校验成功—— (2)");
		    			var date = new Date();
	    				var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
	    				var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
    			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
    			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
    			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
// var logDate = date.getFullYear()+"-"+month+"-"+day+" "
//	+ hours + ":" + minutes + ":" + seconds;   			    	
			    		//解析报文获取锁具编码
			    		var lockId = "";
			    		lockId = that.hexRadixToDecimal(result[2])*Math.pow(256,3) 
			    					+ that.hexRadixToDecimal(result[3])*Math.pow(256,2) 
			    					+ that.hexRadixToDecimal(result[4])*256 
			    					+ that.hexRadixToDecimal(result[5]);
			    		$rootScope.lockId = lockId;
			    		//是否初始化入库状态
			    		if(that.isInit){
			    			if(that.online){
			    				
			    				hlService.home.savePubLocksetData().save({               
				    				lockId : lockId,
				    				lockName : '新锁'+ that.decimalRadixToHex(lockId),
				    				compId : window.localStorage.groupId
				    	      	},function(res){
				    	      		if(res.NUM == -1){
				    	      			$rootScope.showPopup("锁具已在库中!!!");
				    	      		}else{
				    	      			that.sendData(sendDataInfo.join(" "));
				    	      			$rootScope.showPopup("入库成功!!!");
				    	      		}
				    	      	},function(res){
				    	      		$rootScope.showPopup("网络偷懒啦!!!");
				    	      	});
			    			} else{
			    				$rootScope.showPopup("离线状态不支持该功能操作!!!");
			    			}
			    			
			    		} else { //非入库状态
			    			
			    			//判断锁具状态
				    		hlService.home.getPubLocksetByLockId(lockId).get(function(res){
				    			if(res.lockId == null || res.lockId ==""){
				    				$rootScope.showPopup("该锁具未入库，请先入库操作!");
				    				return;
				    			}
				    			var installStatus = res.installStatus;
				    			var assignStatus = res.assignStatus;
				    			if(assignStatus != 1){
				    				$rootScope.showPopup("该锁具未分配,请联系主站管理员!");
				    			} else {
				    				//挂锁模式
					    			if(that.isInstalling){
					    				var installTime = (date/1000).toFixed(0);
					    				if(installStatus == 1 ){
					    					$rootScope.showPopup("该锁具已使用,不用进行此操作!");
					    				} else {
					    					//判断该锁具是否在用户名下
					    					hlService.home.getLockUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}else{
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}
					    					},function(res){
					    						$cordovaToast.showShortCenter("已转离线模式");
					    						var locksets = JSON.parse(window.localStorage.locksets);
					    						var isContain = false;
					    						for(var i=0;i<locksets.length;i++){
					    							var lockset = locksets[i];
					    							if(lockset.lockId == lockId){
					    								isContain = true;
					    								break;
					    							}
					    						}
					    						if(isContain){
					    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
					    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
													+ hours + ":" + minutes + ":" + seconds;
					    							that.installLock((date/1000).toFixed(0),timeFormate);
					    						}else{
					    							$rootScope.showPopup("该锁具未分配到用户下，操作终止!");
					    						}
					    					});
					    				}
					    			}else { //回收和开锁维护模式
					    				if(installStatus != 1){
					    					$rootScope.showPopup("该锁具未使用安装,不进行此操作!");
					    				}else{
					    					//权限判断
					    					hlService.home.getDeviceUserRelByUserIdLockId(lockId,window.localStorage.userId).get(function(res){
					    						if(res.id == null){
					    							$rootScope.showPopup("用户对该设备无操作权限,请联系管理员!");
					    						} else{
					    							var ymd = "" + date.getFullYear() + month + day;
							    			    	var hms = "" + hours + minutes + seconds;
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限判断操作开始—— (3)");   		
							    			    	if(ymd >= res.startDate && ymd <= res.endDate){ //判断是否在规定时间段内维护
							    			    		if(res.type == 0 || res.type == 1){ //每天仅判断时分秒
							        			    		if(hms > res.startTime && hms < res.endTime){
							    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
							    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    	    			    		if(that.isReturn){ // 回收模式，加载数据
							    	    			    			that.setRecoverParams(res);
							    	    			    		}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    } else if(res.type == 2){//每周
							    	    			    	var reDay = res.reday;
							    	    			    	var reDays = reDay.split(",");
							    	    			    	var weekDay = date.getDay();
							    	    			    	var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(weekDay == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							    	    			    	if(isPerm){
							    	    			    		if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)\r\n\r\n"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							    	    			    	}else{
							    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    	    			    	}
							    	    			    }else if(res.type == 3){ //每月
							        			    		var reDay = res.reday;
							        			    		var reDays = reDay.split(",");
							        			    		var isPerm = false;
							    	    			    	for(var i=0;i<reDays.length;i++){
							    	    			    		if(day == reDays[i]){
							    	    			    			isPerm = true;
							    	    			    			break;
							    	    			    		}
							    	    			    	}
							        			    		if(isPerm){
							        			    			if(hms > res.startTime && hms < res.endTime){
							    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n权限校验通过，发送报文—— (4)");							        			    			
								    	    			    		that.sendData(sendDataInfo.join(" "));
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n报文发送成功，开锁结束:" + logDate + "—— (5)"); 
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n\r\n发送报文—— " + sendDataInfo.join(" "));
							    		    			    		if(that.isReturn){ // 回收模式，加载数据
								    	    			    			that.setRecoverParams(res);
								    	    			    		}
							    		    			    	}else{
							    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    		    			    	}
							        			    		}else{
							        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							        			    		}
							    	    			    }
							    			    		
							    			    	}else{
							    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
							    			    	}
					    						}
					    					},function(res){
					    						$rootScope.showPopup("网络偷懒啦!");
					    					});
					    				}
					    			}
				    			}
				    		},function(res){
				    			
				    			$cordovaToast.showShortCenter("网络连接不可用");
				    			//挂锁模式
				    			if(that.isInstalling){
				    				var locksets = JSON.parse(window.localStorage.locksets);
					    			var isContain = false;
					    			for(var i=0;i<locksets.length;i++){
					    				var record = locksets[i];
					    				if(record.lockId == $rootScope.lockId){
					    					isContain = true;
					    					$scope.outLineLockSet = record;
					    					break;
					    				}
					    			}
					    			if(!isContain){
					    				$rootScope.showPopup("该锁具不在库中或你没权限操作，请联网后再进一步操作!");
					    			} else {
					    				//判断锁具是否已使用且已在缓存数据中
					    				var hisRecord = JSON.parse(window.localStorage.lockInstallData);
				    		    		var lockContain = false;
				    		    		
				    		    		for(var i=0;i<hisRecord.length;i++){
				    		    			var record = hisRecord[i];
				    		    			if(record.lockId == lockId){
				    		    				lockContain = true;
				    		    			}
				    		    		}
				    		    		if(lockContain){
				    		    			$rootScope.showPopup("该锁具已使用且缓存，请重新选择!!!");
				    		    		} else{
				    		    			var installTime = (date/1000).toFixed(0);
						    				if($scope.outLineLockSet.lockSet.installStatus == 1 ){
						    					$rootScope.showPopup("该锁具已使用,不再进行此操作!");
						    				} else {
				    							$rootScope.bluetooth.sendData(sendDataInfo.join(" "));
				    							var timeFormate = date.getFullYear()+"-"+month+"-"+day+" "
												+ hours + ":" + minutes + ":" + seconds;
				    							that.installLock((date/1000).toFixed(0),timeFormate);
						    				}
				    		    		}
					    			}
				    			}else{  // 开关维护及回收模式
				    				var devices = JSON.parse(window.localStorage.lockPerm);
				    				var isContain = false;
				    				for(var i=0;i<devices.length;i++){
				    					var record = devices[i];
				    					var realLockId = record.device.lockId;
				    					if(realLockId == lockId){
				    						isContain = true;
				    						$scope.outLineDevice = record;
				    						break;
				    					}
				    				}
				    				if(!isContain){
				    					$rootScope.showPopup("该锁具未安装或用户对该设备无操作权限，请联网后再进一步操作。");
				    				}else{
				    					
				    					var ymd = "" + date.getFullYear() + month + day;
				    			    	var hms = "" + hours + minutes + seconds;
				    			    	if(ymd >= $scope.outLineDevice.startDate && ymd <= $scope.outLineDevice.endDate){ //判断是否在规定时间段内维护
				    			    		if($scope.outLineDevice.type == 0 || $scope.outLineDevice.type == 1){ //每天仅判断时分秒
				        			    		if(hms > $scope.outLineDevice.startTime && hms < $scope.outLineDevice.endTime){
				    	    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    	    			    		that.sendData(sendDataInfo.join(" "));
				    	    			    		if(that.isReturn){ // 回收模式，加载数据
				    	    			    			that.setRecoverParams($scope.outLineDevice);
				    	    			    		}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    } else if($scope.outLineDevice.type == 2){//每周
				    	    			    	var reDay = $scope.outLineDevice.reday;
				    	    			    	var reDays = reDay.split(",");
				    	    			    	var weekDay = date.getDay();
				    	    			    	var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(weekDay == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				    	    			    	if(isPerm){
				    	    			    		if(hms > $scope.outLineDevice.startTime && hms < $scope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				    	    			    	}else{
				    	    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    	    			    	}
				    	    			    }else if($scope.outLineDevice.type == 3){ //每月
				        			    		var reDay = $scope.outLineDevice.reday;
				        			    		var reDays = reDay.split(",");
				        			    		var isPerm = false;
				    	    			    	for(var i=0;i<reDays.length;i++){
				    	    			    		if(day == reDays[i]){
				    	    			    			isPerm = true;
				    	    			    			break;
				    	    			    		}
				    	    			    	}
				        			    		if(isPerm){
				        			    			if(hms > $scope.outLineDevice.startTime && hms < $scope.outLineDevice.endTime){
				    		    			    		//var data = '04 05 f8 f6 f9 f4 e6 e5';
				    		    			    		that.sendData(sendDataInfo.join(" "));
				    		    			    		if(that.isReturn){ // 回收模式，加载数据
					    	    			    			that.setRecoverParams(res);
					    	    			    		}
				    		    			    	}else{
				    		    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    		    			    	}
				        			    		}else{
				        			    			$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				        			    		}
				    	    			    }
				    			    	}else{
				    			    		$rootScope.showPopup("超出授权时段范围，不予操作!!!");
				    			    	}
				    			    	
				    				}
				    				
				    			}
				    			
				    		});
			    		}
		    		}
		    	}
		    	else if(result[0]==1){
		    		that.keyInfo = result;
		    	}
		    	else if(result[0]==4){
		    		var date = new Date();
					var month = (date.getMonth()+1) < 10 ? '0'+(date.getMonth()+1) : (date.getMonth()+1);
			    	var day = date.getDate() < 10 ? '0'+ date.getDate() : date.getDate();
			    	var hours = date.getHours() < 10 ? '0' + date.getHours() : date.getHours();
			    	var minutes = date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes();
			    	var seconds = date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds();
		    		//判断是否开锁维护状态
		    		if(that.isMain){
		    			var ymd = date.getFullYear() + "-" + month + "-" + day;
				    	var hms = hours + ":" + minutes + ":" + seconds;
			    		$rootScope.openLog = "用户" + window.localStorage.userName + "于" + ymd + " " + hms +"有开启智能锁。"
			    		if(that.online){

			    			hlService.home.savePubHisData().save({
				          		userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)
				          	},function(res){
//$rootScope.writeFile($rootScope.fileURL,$rootScope.fileName,"\r\n保存开锁日志—— (6)\r\n\r\n");
				          	});
			    		}else{
			    			var hisRecord = JSON.parse(window.localStorage.hisData);
			    			var record = {
		    					userId : window.localStorage.userId, 
				          		lockId : $rootScope.lockId,
				          		optDate : (date/1000).toFixed(0)	
			    			}
		    				window.localStorage.hisData = JSON.stringify(hisRecord.concat(record));
		    				$rootScope.showPopup("已缓存开锁记录!!!");
			    		}
		    		}
		    	}
		    },
		    /**
			 * 写数据
			 * */
		    sendData : function(data){
				ble.write($rootScope.bluetooth.deviceId, $rootScope.bluetooth.serviceUUID, $rootScope.bluetooth.characteristicUUID,
	    				$rootScope.bluetooth.stringToBytes(data).buffer, function(res){
				},$rootScope.bluetooth.onError);
			},
		    disconnect : function(){
		    	ble.disconnect($rootScope.bluetooth.deviceId,function(){
		    		$rootScope.status = "未连接";
				},function(){});
		    }
	    };
		return Bluetooth;
	};
})
.controller('common.home',function($scope,$rootScope,$stateParams,$state,$interval,$ionicPopup,$timeout,$ionicPopover,hlService){
	$rootScope.bluetooth.isInstalling = false;
	$rootScope.bluetooth.isReturn = false;
	$rootScope.bluetooth.isInit = false;
	$rootScope.bluetooth.isMain = true;
    //1 …………………………………………………………连接设备
    if($rootScope.bluetooth.scanFlag){
    	$rootScope.status = "未连接";
        if(ionic.Platform.isIOS()){
            $rootScope.bluetooth.scanDevice();
        }else if(ionic.Platform.isAndroid()){
            ble.enable(function(){
                $rootScope.bluetooth.scanDevice();
            });
        }
    }
  
    //2 …………………………………………………………处理状态显示
    var getStatus = function(){
    	if($rootScope.status == "已连接"){
    		$scope.getKeyDetail();
    		$rootScope.bluetooth.connected = true;
    		//$scope.getPermissionListCount(); //实时更新权限数据
    	}else{
    		$rootScope.status = "未连接";
    		if($rootScope.bluetooth.connected){ //已连接中断，尝试二次连接
    			$rootScope.bluetooth.scanDevice();
    		}
    	}
    }
    //3 ……………………………………………………………获取连接钥匙基本信息
    $scope.getKeyDetail = function(){
    	var data = '01 00 00';
    	$rootScope.bluetooth.sendData(data);
    	
    	$timeout(function(){
    		var responseKeyInfo = $rootScope.bluetooth.keyInfo
    		if(responseKeyInfo){
    			var firstData = parseInt(responseKeyInfo[8],16);
    			var secondData = parseInt(responseKeyInfo[9],16);
    			var voltage = firstData * 256 + secondData;
    			$rootScope.version = "版本 : version1";
    			if(voltage > 4100){
    				$rootScope.voltage = "钥匙电量:100%";
    			} else if(voltage < 3700){
    				$rootScope.voltage = "钥匙电量:0%";
    			} else {
    				var quantity = (voltage - 3700) / (0.4 * 1000);
        			$rootScope.voltage = "钥匙电量:" + (quantity*100).toFixed(2) + "%";
    			}
    			
    		}
    	},5000);
    }
    var statusTimeout = $interval(getStatus,1000);
    /**
     * 处理页面功能按钮显示
     * */
    $scope.initBtnShow = false;
    $scope.installBtnShow = false;
    $scope.recoverBtnShow = false;
    $scope.mainBtnShow = false;
    var opts = window.localStorage.opt.split(",");
    for(var i=0;i<opts.length;i++){
    	var opt = opts[i];
    	if(opt == 0){
    		$scope.initBtnShow = true;
    	} else if(opt == 1){
    		$scope.installBtnShow = true;
    	} else if(opt == 2){
    		$scope.mainBtnShow = true;
    	}else if(opt ==3){
    		$scope.recoverBtnShow = true;
    	}
    }
    
    //4 ………………………………………………………………开锁记录页面
    $scope.getHisData = function(){
    	
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('hisData');
    	
    }
    
    //5 ………………………………………………………………用户权限页面
    $scope.getPermData = function(){
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('permData');
    }
    
   //6 ………………………………………………………………地图页面
    $scope.getLocationData = function(){
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = true;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('locationData');
    }
    
    //7 ………………………………………………………………获取权限记录数量 …………………………未使用
    $scope.getPermissionListCount = function(){
    	var userId = window.localStorage.userId;
    	hlService.home.getPermissionListCount(window.localStorage.userId).get(function(res){
    		var permCount = res.NUM;
    		if(permCount != $rootScope.lockPerm.length){
    			//获取新的权限列表信息	
    			hlService.home.getPermissionListByUserId(window.localStorage.userId).query(function(res){
    				$rootScope.lockPerm = res;
    				window.localStorage.lockPerm = JSON.stringify(res);
    	    	});
    		}
    	});
    };
    
    //8 ………………………………………………………………安装锁具
    $scope.installLockset = function(){
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = true;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = false;
    	$state.go('installLockset');
    }
    
    //9 ………………………………………………………………右上角弹出菜单
	$ionicPopover.fromTemplateUrl('pages/menu.html', {
      scope: $scope
    }).then(function(popover) {
        $scope.popover = popover;
    });
    $scope.openPopover = function($event) {
      $scope.popover.show($event);
    };
    $scope.closePopover = function() {
      $scope.popover.hide();
    };
    $scope.$on('$destroy', function() {
      $scope.popover.remove();
    });
    
    //10 ………………………………………………………………新锁具入库操作
    $scope.count = 0;
    $scope.noActive = true;
	$scope.isActive = false;
    $scope.initBtnHandler = function(){
    	$scope.count += 1; 
    	if($scope.count%2 != 0){
    		$scope.noActive = false;
        	$scope.isActive = true;
        	$rootScope.bluetooth.isInit = true;
        	$rootScope.bluetooth.isInstalling = false;
        	$rootScope.bluetooth.isMain = false;
        	$rootScope.bluetooth.isReturn = false;
        	
    	}else{
    		$scope.noActive = true;
        	$scope.isActive = false;
        	$rootScope.bluetooth.isInit = false;
        	$rootScope.bluetooth.isMain = true;
        	$rootScope.bluetooth.isReturn = false;
        	$rootScope.bluetooth.isInstalling = false;
    	}
    	
    }
    
    //11 …………………………………………………………………回收操作
    $scope.recoverLockset = function(){
    	$rootScope.bluetooth.scanFlag = false;
    	$rootScope.bluetooth.isInstalling = false;
    	$rootScope.bluetooth.isMain = false;
    	$rootScope.bluetooth.isInit = false;
    	$rootScope.bluetooth.isReturn = true;
    	$state.go('recoverLockset');
    }
    
    //未上锁设备加载
    hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
		$scope.deviceList = res;
		window.localStorage.deviceList = JSON.stringify(res);
	},function(res){
		$scope.deviceList = JSON.parse(window.localStorage.deviceList);
	});
})
.controller('common.hisData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService){
	
	$scope.getPubHisDataByUserId = function(){
		hlService.home.getPubHisDataListByUserId(window.localStorage.userId).query(function(res){
			for(var i=0;i<res.length;i++){
				var obj = res[i];
				obj.DATE = dateFormate(obj.OPT_DATE);
				res[i] = obj;
			}
			
			$scope.hisDataList = res;
			window.localStorage.hisDataList = JSON.stringify(res);
			$scope.$broadcast('scroll.refreshComplete');
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.hisDataList = JSON.parse(window.localStorage.hisDataList);
		});
	};
	$scope.getPubHisDataByUserId();
	
	var dateFormate = function(time){
		var date = new Date(time*1000);
		return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate() + " "
				+ date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
	}
})
.controller('common.permData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService){
	
	$scope.getPermListByUserId = function(){
		hlService.home.getPermissionListByUserId(window.localStorage.userId).query(function(res){
			for(var i=0;i<res.length;i++){
				var obj = res[i];
				obj.startDate = dateFormate(obj.startDate);
				obj.endDate = dateFormate(obj.endDate);
				obj.startTime = timeFormate(obj.startTime);
				obj.endTime = timeFormate(obj.endTime);
				obj.typeDesc = reTypeFormate(obj.type);
				obj.reday = reDayFormate(obj.type,obj.reday);
				res[i] = obj;
			}
			
			$scope.lockPermList = res;
			window.localStorage.lockPermList = JSON.stringify(res);
		},function(res){
			$scope.$broadcast('scroll.refreshComplete');
			$scope.lockPermList = JSON.parse(window.localStorage.lockPermList);
		});
	};
	$scope.getPermListByUserId();
	
	var dateFormate = function(date){
		date = date + " ";
		var year = date.substring(0,4);
		var month = date.substring(4,6);
		var day = date.substring(6,8);
		return year + "-" + month + "-" + day;
	}
	
	var timeFormate = function(time){
		time = time + "";
		if(time.length == 5){
			var hour = time.substring(0,1);
			var minutes = time.substring(1,3);
			var seconds = time.substring(3,5);
			return hour + ":" + minutes + ":" + seconds;
		}else if(time.length == 6){
			var hour = time.substring(0,2);
			var minutes = time.substring(2,4);
			var seconds = time.substring(4,6);
			return hour + ":" + minutes + ":" + seconds;
		}else{
			return time;
		}
	}
	
	var reTypeFormate = function(type){
		if(type == 0){
			return "不重复";
		} else if(type == 1){
			return "每天";
		} else if(type == 2){
			return "每周";
		} else if(type == 3){
			return "每月";
		}
	}
	
	var reDayFormate = function(type,reDay){
		if(reDay != null){
			if(type == 2){
				var day = ["周日","周一","周二","周三","周四","周五","周六"];
				var reDays = reDay.split(",");
				var format = "";
				for(var i=0;i<reDays.length;i++){
					format += day[reDays[i]] + ",";
				}
				return format.substring(0, format.length-1);
			}else if(type == 3){
				if((reDay.split(",")).length>8){
					var reDays = reDay.split(",");
					var format = "";
					for(var i=0;i<8;i++){
						format += reDays[i] + ",";
					}
					return format+"……";
				}else{
					return reDay + "号";
				}
				
			}
		}else{
			return "";
		}
		
	}
	
})
.controller('common.mapData',function($scope,$rootScope,$stateParams,$state,$interval,$timeout,hlService){
	var lng = $stateParams.lng;
	var lat = $stateParams.lat;
	var map = new BMap.Map("container");
    map.addControl(new BMap.MapTypeControl());
    map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
    map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
    map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
    map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
    map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开	
    var localSearch = new BMap.LocalSearch(map);
    localSearch.enableAutoViewport(); //允许自动调节窗体大小
    
    if(lng != "" && lat != ""){
    	var point = new BMap.Point(lng,lat);
    	map.centerAndZoom(point, 20);
    	var marker = new BMap.Marker(point);  
        map.addOverlay(marker);  
    } else {
    	//定位信息
    	var geolocation = new BMap.Geolocation();
    	geolocation.getCurrentPosition(function(r){
    		if(this.getStatus() == BMAP_STATUS_SUCCESS){
    			var longitude = r.point.lng;
    			var latitude = r.point.lat;
    			
    			var point = new BMap.Point(longitude,latitude);
    			map.centerAndZoom(point,20);
    			
    			var startLng = longitude - 0.01;
    			var endLng = longitude + 0.01;
    			var startLat = latitude - 0.01;
    			var endLat = latitude + 0.01;
    			//获取方圆范围内的点，后台已舍弃条件删选返回了所有点 -- leaf
    			hlService.home.getPubLocksetByPoint(window.localStorage.userId,startLng,endLng,startLat,endLat).query(function(res){
    				for(var i=0;i<res.length;i++){
    					var record = res[i];
    					var maker = addMarker(new window.BMap.Point(record.LONGITUDE, record.LATITUDE), i,record);  
                       // addInfoWindow(maker, record, i); 
    				}
    			},function(res){
    				$rootScope.showPopup("网络偷懒啦!!!");
    			});
    		} 
    		else {
    			$rootScope.showPopup("地址定位失败：" + this.getStatus());
    		}        
    	},{enableHighAccuracy: true});
    	
    }
	
 
    
    
	// 添加标注  
    function addMarker(point, index,record) {  
        var myIcon = new BMap.Icon("http://api.map.baidu.com/img/markers.png",  
            new BMap.Size(23, 25), {  
                offset: new BMap.Size(10, 25),  
                imageOffset: new BMap.Size(0, 0 - index * 25)  
            });  
        var marker = new BMap.Marker(point);  
        
        
        
        //pop弹窗标题  
        var title = '<div style="font-weight:bold;color:#CE5521;font-size:14px;text-align:center;">' + record.DEVNAME + '</div>';  
        //pop弹窗信息  
        var html = [];  
        html.push('<table cellspacing="0" style="table-layout:fixed;width:100%;font:12px arial,simsun,sans-serif"><tbody>');  
        html.push('<tr>');  
        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">位置:</td>');  
        html.push('<td style="vertical-align:top;line-height:16px">' + record.LOCATION + '</td>');  
        html.push('</tr>');
        html.push('<tr>');  
        html.push('<td style="vertical-align:top;line-height:16px;width:30%;margin-top:10px;">上锁时间:</td>');  
        html.push('<td style="vertical-align:top;line-height:16px;margin-top:10px;">' + dateFormate(record.TIME) + ' </td>');  
        html.push('</tr>');  
        html.push('</tbody></table>');  
        var searchInfoWindow = null;
    	searchInfoWindow = new BMapLib.SearchInfoWindow(map, html.join(""), {
			title  : title,      //标题
			width  : 290,             //宽度
			height : 85,              //高度
			panel  : "panel",         //检索结果面板
			enableSendToPhone:false,
			enableAutoPan : true,     //自动平移
			searchTypes   :[
				BMAPLIB_TAB_TO_HERE,  //到这里去
				BMAPLIB_TAB_FROM_HERE, //从这里出发
				BMAPLIB_TAB_SEARCH   //周边检索 
			],
			currentAddr : '上海浦东新区龙东大道3000号'        //自定义属性   -- by leaf
		});
        
    	marker.addEventListener("click", function(e){
    	    searchInfoWindow.open(marker);
        })
        
        
        map.addOverlay(marker);  
        
        marker.setLabel(new BMap.Label(record.DEVNAME,{offset:new BMap.Size(-20,20),position:point}));
        return marker;  
    }  
//
//    // 添加信息窗口  
//    function addInfoWindow(marker, record) {  
//    	
//        //pop弹窗标题  
//        var title = '<div style="font-weight:bold;color:#CE5521;font-size:14px;text-align:center;">' + record.DEVNAME + '</div>';  
//        //pop弹窗信息  
//        var html = [];  
//        html.push('<table cellspacing="0" style="table-layout:fixed;width:100%;font:12px arial,simsun,sans-serif"><tbody>');  
//        html.push('<tr>');  
//        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">上锁时间:</td>');  
//        html.push('<td style="vertical-align:top;line-height:16px">' + dateFormate(record.TIME) + ' </td>');  
//        html.push('</tr>');  
//        html.push('<tr>');  
//        html.push('<td style="vertical-align:top;line-height:16px;width:30%;white-space:nowrap;word-break:keep-all">地点:</td>');  
//        html.push('<td style="vertical-align:top;line-height:16px">' + record.LOCATION + '</td>');  
//        html.push('</tr>');
//        html.push('</tbody></table>');  
//        var infoWindow = new BMap.InfoWindow(html.join(""), { title: title, width: 200 });  
//        var openInfoWinFun = function () {  
//            marker.openInfoWindow(infoWindow);  
//        };  
//        marker.addEventListener("click", openInfoWinFun);  
//        return openInfoWinFun;
//    }
   
    var dateFormate = function(time){
		if(time !=0 && time != null){
			var date = new Date(time*1000);
			return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate();
		}else{
			return 0;
		}
	}
    
})
.controller('common.mapLead',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	
	
	
	
	
	
	var map = new BMap.Map("leadMap");
    map.addControl(new BMap.MapTypeControl());
    map.enableScrollWheelZoom(false);    //启用滚轮放大缩小，默认禁用
    map.enableContinuousZoom();    //启用地图惯性拖拽，默认禁用
    map.addControl(new BMap.NavigationControl());  //添加默认缩放平移控件 
    map.addControl(new BMap.OverviewMapControl()); //添加默认缩略地图控件
    map.addControl(new BMap.OverviewMapControl({ isOpen: false, anchor: BMAP_ANCHOR_BOTTOM_RIGHT }));   //右下角，打开	
    var localSearch = new BMap.LocalSearch(map);
    localSearch.enableAutoViewport(); //允许自动调节窗体大小
	
    var point = new BMap.Point(121.639940,31.228950);
	map.centerAndZoom(point, 20);
	var marker = new BMap.Marker(point);  
    map.addOverlay(marker);  
    
    
    
    
    
    
}])
.controller('common.installLockset',['$scope','$rootScope','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	
	var dateFormate = function(time){
		if(time !=0 && time != null){
			var date = new Date(time*1000);
			return date.getFullYear() + "-" + (date.getMonth()+1) + "-" + date.getDate();
		}else{
			return 0;
		}
	}
	
	hlService.home.getPubAreaData().query(function(res){
		$scope.areaList = res;
		window.localStorage.areaDataList = JSON.stringify(res);
	},function(res){
		$scope.areaList = JSON.parse(window.localStorage.areaDataList);
	});
	
	hlService.home.getDeviceSelectsByUserId(window.localStorage.userId).query(function(res){
		$scope.deviceList = res;
		window.localStorage.deviceList = JSON.stringify(res);
	},function(res){
		$scope.deviceList = JSON.parse(window.localStorage.deviceList);
		
	});
	
	$scope.saveInstallInfo = function(lockset){
		if(lockset.device.DEVICEID===null || lockset.device.DEVICEID===""){
			$rootScope.showPopup("请先选择挂锁设备信息");
			return;
		}
		if($rootScope.bluetooth.online){
			var params = {
				lockId : lockset.lockId,
				deviceId : lockset.device.DEVICEID,
				deviceName : lockset.device.DEVNAME,
				location : lockset.location,
				installer : $rootScope.Lockset.installer,
				time : $rootScope.Lockset.time,
				longitude : lockset.longitude,
				latitude : lockset.latitude
			};
			hlService.home.updateInstallLocksetData().save(params,function(res){
	      		if(res.NUM == -1){
	      			$rootScope.showPopup("挂锁信息未成功入库!!!");
	      		}else{
	      			$rootScope.showPopup("保存成功!!!");
	      			$rootScope.Lockset={};
	      		}
	      	},function(res){
	      		$rootScope.showPopup("网络偷懒啦!!!");
	      	});
		}else{
			var hisRecord = JSON.parse(window.localStorage.lockInstallData);
    		var isContain = false;
    		for(var i=0;i<hisRecord.length;i++){
    			var record = hisRecord[i];
    			if(record.deviceId == lockset.device.DEVICEID){
    				isContain = true;
    			}
    		}
    		if(isContain){
    			$rootScope.showPopup("该设备已上锁且缓存，请重新选择!!!");
    		} else{
    			var locksetRecord = {
					lockId : lockset.lockId,
					deviceId : lockset.device.DEVICEID,
					deviceName : lockset.device.DEVNAME,
					location : lockset.location,
					installer : $rootScope.Lockset.installer,
					time : $rootScope.Lockset.time
		      	};
				window.localStorage.lockInstallData = JSON.stringify(hisRecord.concat(locksetRecord));
				$rootScope.showPopup("已缓存!!!");
				$rootScope.Lockset={};
    		}
		}
	}
	
	$scope.locationHandler = function(Lockset){
		if(Lockset.longitude!="" && Lockset.longitude!=null && Lockset.longitude!=undefined){
			$state.go("locationData",{lng:Lockset.longitude,lat:Lockset.latitude});
		}
		
	}
	
	$scope.judgeInstalled = function(device){
		var deviceId = device.DEVICEID;
		hlService.home.getDeviceInstalled(deviceId).get(function(res){
			//是否已上鎖
    	},function(res){
    		var hisRecord = JSON.parse(window.localStorage.lockInstallData);
    		var isContain = false;
    		for(var i=0;i<hisRecord.length;i++){
    			var record = hisRecord[i];
    			if(record.deviceId == deviceId){
    				isContain = true;
    				break;
    			}
    		}
    		if(isContain){
    			$rootScope.showPopup("该设备已上锁且缓存，请重新选择!!!");
    		} else{
    			$rootScope.Lockset.location = device.LOCATION;
    		}
    		
    	});
	}
	
	
}])
.controller('common.recoverLockset',['$scope','$rootScope','$cordovaToast','$stateParams','$interval','$timeout','$ionicPopup','hlService','$state',
    function($scope,$rootScope,$cordovaToast,$stateParams,$interval,$timeout,$ionicPopup,hlService,$state){
	$rootScope.recover = {};
	
	$scope.submitRecoverInfo = function(recover){
		var recover = $rootScope.recover;
		if(recover.lockId == "" || recover.lockId == null){
			return;
		}
		hlService.home.updateRecoverLocksetData().save({
			lockId : recover.lockId,
			deviceId : $rootScope.recover.deviceId,
			deviceName : recover.deviceName,
			location : $rootScope.recover.location,
			installer : '',
			time : 0,
			longitude : 0,
			latitude : 0
      	},function(res){
      		if(res.NUM == -1){
      			$rootScope.showPopup("锁具回收状态更新失败!!!");
      		}else{
      			$rootScope.showPopup("状态更新成功!!!");
      			$rootScope.recover={};
      		}
      	},function(res){
      		$cordovaToast.showShortCenter("网络连接不可用");
      		//$rootScope.showPopup("网络偷懒啦!!!");
      		//离线
      		var hisRecoverData = JSON.parse(window.localStorage.recoverData);
      		var recoverRecord = {
  				lockId : recover.lockId,
  				deviceId : $rootScope.recover.deviceId,
  				deviceName : recover.deviceName,
  				location : $rootScope.recover.location,
  				installer : '',
  				time : 0,
  				longitude : 0,
  				latitude : 0
	      	};
      		window.localStorage.recoverData = JSON.stringify(hisRecoverData.concat(recoverRecord));
			$rootScope.showPopup("已缓存!!!");
			$rootScope.recover={};
      	});
	}
}]);

